-- Project StreetzRPG: masterscript (author: Bryan Mader)
-- Game version v0.29 Alpha (open LOVE2D forum release) 19 APR 22

-- LAST CLEANUP: 14 APR 19
function love.load()
print("- INITIALIZING STREETZRPG -")
-- | code shortcuts
lf = love.filesystem
ls = love.sound
la = love.audio
lg = love.graphics
lk = love.keyboard
function newAnimation(image, width, height, duration)
    local animation = {}
    animation.spriteSheet = image;
	animation.quads = {};
    for y = 0, image:getHeight() - height, height do
        for x = 0, image:getWidth() - width, width do
            table.insert(animation.quads, love.graphics.newQuad(x, y, width, height, image:getDimensions()))
        end
    end
	animation.duration = duration
    animation.currentTime = 0
    return animation
end
-- | master game tables
n = {}
n.inv = false
n.dmgind = 0
n.dmgind_on = true
n.marker = {}
n.marker.pos_x = -999
n.marker.pos_y = -999
n.marker.tpos_x = -999; n.marker.tpos_y = -999
n.marker.style = nil
n.marker.active = false
n.marker.hood = 0
n.mpos = false
n.hp_given = 0
n.ap_given = 0
n.hp_prior = 0 -- devmode utils
n.ap_prior = 0
n.canselldrug = false -- offerdrug utils
n.tosell = nil
n.sellamount = nil
n.canX = nil -- proximity/npc/event utils
n.canY = nil
n.talkingto = nil
n.convo = false
n.actuallyquickgascop = false
n.version = "0.29-R1" -- misc
n.hasshown = false
n.lastsaved = nil
-- | player
player = {}
player.hasticket = false
player.house = nil -- (1) northmid
player.priceweed = 20
player.pricecoke = 80
player.ismoving = false
player.y = 250 -- drawpos, not actual world position
player.x = 275
player.speed = 2
player.regularspeed = player.speed
player.fastspeed = player.speed * 2
player.slowspeed = player.speed / 2
player.cash = 999999
player.hp = 999
player.maxhp = 999
player.ap = 999
player.maxap = 999
player.age = 25
player.lvl = 99
player.kills = 0
player.deaths = 0
player.xp = 0
player.maxxp = 10
player.faction = "Parkwood City PD" -- player factions
player.factionid = 0 -- (0) civilian (1) pd (2) fd (3) gang1/perpz (4) gang2/killas (5) gang3/leyendas (6) trucking
player.factionrank = "nil"
player.factionrankid = 0 -- x out of 5
player.odskin1 = nil
player.odskin2 = nil
player.odskin3 = nil
player.factionduty = false
player.name = "First Last"
player.name = "First Last"
player.race = "wma"
player.issprinting = false -- player conditions
player.cansprint = true
player.isaiming= false
player.incombat = false
player.canmove = true
player.isdown = false
player.inint = false
player.isdragging = false
player.dragging = false
player.incar = false
player.face = 3 -- (north) 1 (east) 2 (south) 3 (west) 4
player.face2 = 0 -- (0): none
player.hpcolor = {1, 1, 1}
player.skin = 'nil'
player.wanted = false
--| sidejob data
player.job = nil -- (0) unemployeed/faction (1) delivery (2) fishing (3) mechanic (4) taxi
player.job_rank = 1 -- (1) trainee (2) novice (3) experienced (4) master (5) expert
player.job_xp = 0 -- jobs done
player.job_active = false
player.jobdata = {nil, nil}
-- misc
player.dragx = nil
player.dragy = nil
-- player clothing/accessories
player.clothes = {}
player.clothes.torso = lg.newImage("clothes/none.png")
player.clothes.torso_f = player.clothes.torso
player.clothes.torso_b = player.clothes.torso
player.clothes.hand = lg.newImage("clothes/none.png")
player.clothes.goreX = 250
player.clothes.goreY = 250
player.clothes.torsoX = player.x
player.clothes.torsoY = player.y
player.clothes.handX = 250
player.clothes.handY = 250
-- player weapons
player.weapons = {}
player.weapons.slot0 = "Fists" -- fists, knuckles, nightstick, knife
player.weapons.slot1 = "9mm Pistol" -- 9mm pistol, .44 magnum, scorpion
player.weapons.slot2 = "Super Shorty" -- super shorty, sawed-off, spas
player.weapons.slot3 = "AK-47" -- ak-47, mp5, m4 carbine
player.weapons.has1 = false
player.weapons.has2 = false
player.weapons.has3 = false
player.weapons.clip1 = 7
player.weapons.maxclip1 = 7
player.weapons.ammo1 = 70
player.weapons.clip2 = 3
player.weapons.maxclip2 = 3
player.weapons.ammo2 = 30
player.weapons.clip3 = 30
player.weapons.maxclip3 = 30
player.weapons.ammo3 = 300
player.weapons.weapontxtr = lg.newImage("clothes/none.png")
player.weapons.selected = "fists"
-- | dialog
dialog = {}
dialog.active = false
dialog.options = {"nil", "nil"}
dialog.colors = {0, 0, 0}
dialog.deal = false
-- | inv
inv = {}
inv.coke = {}
inv.coke.qnty = 0
inv.weed = {}
inv.weed.qnty = 0
inv.cigs = {}
inv.cigs.qnty = 20
inv.fourty = {}
inv.fourty.qnty = 0
inv.gum = {}
inv.gum.qnty = 0
inv.candybar = {}
inv.candybar.qnty = 0
inv.fbucket = {}
inv.fbucket.has = false
inv.fbucket.slot1_weight = 0
inv.fbucket.slot1_breed = "nil"
inv.fbucket.slot1_worth = 0
inv.fbucket.slot2_weight = 0
inv.fbucket.slot2_breed = "nil"
inv.fbucket.slot2_worth = 0
inv.fbucket.slot3_weight = 0
inv.fbucket.slot3_breed = "nil"
inv.fbucket.slot3_worth = 0
inv.fbucket.slot4_weight = 0
inv.fbucket.slot4_breed = "nil"
inv.fbucket.slot4_worth = 0
inv.fbucket.slot5_weight = 0
inv.fbucket.slot5_breed = "nil"
inv.fbucket.slot5_worth = 0
inv.frod = {}
inv.frod.has = false
inv.frod.hp = 100
inv.bait = {}
inv.bait.qnty = 100
-- | world
world = {}
world.x = love.math.random(-1400, 00)
world.y = love.math.random(-1400, 200)
-- | service/util
svc = {}
svc.lastcmd = "nil"
svc.walkanim = 0
svc.walkanimmax = 0
svc.fireak = 0
svc.fireakmax = 20
svc.fireglock = 0
svc.fireglockmax = 25
svc.fireshorty = 0
svc.fireshortymax = 1.0
svc.wantedtimer = 0
svc.wantedtimermax = 50
-- | textures
txtrs = {}
txtrs.city = {}
-- items
txtrs.items = {}
txtrs.items.weed = lg.newImage("inv/weed.png")
txtrs.items.beer = lg.newImage("inv/beer.png")
txtrs.items.coke = lg.newImage("inv/coke.png")
-- city
txtrs.city.southeast = lg.newImage("city/southeast.png")
txtrs.city.southmid = lg.newImage("city/southmid.png")
txtrs.city.southwest = lg.newImage("city/southwest.png")
txtrs.city.downtown = lg.newImage("city/downtown.png")
txtrs.city.midwest = lg.newImage("city/midwest.png")
txtrs.city.mideast = lg.newImage("city/mideast.png")
txtrs.city.northwest = lg.newImage("city/northwest.png")
txtrs.city.northmid = lg.newImage("city/northmid.png")
txtrs.city.northeast = lg.newImage("city/northeast.png")
txtrs.city.txtr = txtrs.city.southeast
-- interiors
txtrs.int = {}
txtrs.int.gun = lg.newImage("int/gun.png")
txtrs.int.gas1 = lg.newImage("int/gas1.png")
txtrs.int.pd = lg.newImage("int/pd.png")
txtrs.int.fd = lg.newImage("int/fd.png")
txtrs.int.clothes = lg.newImage("int/clothes.png")
txtrs.int.tav = lg.newImage("int/tav.png")
txtrs.int.sub = lg.newImage("int/sub.png")
txtrs.int.phouse1 = lg.newImage("int/phouse1.png")
-- player
txtrs.chatbox = lg.newImage("hud/chatbox.png")
txtrs.vig = lg.newImage("hud/vig.png")
txtrs.marker1 = lg.newImage("hud/marker1.png")
txtrs.player = txtrs.playerdn
txtrs.skins = {}
-- civilian skins
txtrs.skins.qgas1 = lg.newImage("skins/sprite/qgas1.png")
-- cars
txtrs.vehs = {}
txtrs.vehs.cruiser1 = lg.newImage("vehs/cruiser1.png")
txtrs.vehs.cruiser2 = lg.newImage("vehs/cruiser2.png")
txtrs.vehs.rig1 = lg.newImage("vehs/roadrunner.png")
txtrs.vehs.cab1 = lg.newImage("vehs/cab1.png")
-- clothing accessories
txtrs.clothes = {}
txtrs.clothes.vestpd_f = lg.newImage("clothes/vestpd_f.png")
txtrs.clothes.vestpd_b = lg.newImage("clothes/vestpd_b.png")
txtrs.clothes.vestcivf = lg.newImage("clothes/vestciv_f.png")
txtrs.clothes.vestcivb = lg.newImage("clothes/vestciv_f.png")
txtrs.clothes.joint = lg.newImage("clothes/joint.png")
txtrs.clothes.beer = lg.newImage("clothes/beer.png")
txtrs.clothes.frod = lg.newImage("clothes/frod.png")
txtrs.clothes.none = lg.newImage("clothes/none.png")
txtrs.clothes.gore = lg.newImage("clothes/gore.png")
txtrs.clothes.cuffs = lg.newImage("clothes/cuffs.png")
txtrs.clothes.ciggy = lg.newImage("clothes/cig.png")
txtrs.clothes.cuffs = lg.newImage("clothes/cuffs.png")
txtrs.clothes.shot1 = lg.newImage("clothes/shot1.png")
txtrs.clothes.shot2 = lg.newImage("clothes/shot2.png")
player.clothes.gore = txtrs.clothes.none
-- weapons
txtrs.weapons = {}
txtrs.weapons.glockf = lg.newImage("weapons/glockf.png")
txtrs.weapons.glockl = lg.newImage("weapons/glock_l.png")
txtrs.weapons.glockr = lg.newImage("weapons/glock_r.png")
txtrs.weapons.glockb = lg.newImage("weapons/glock_b.png")
txtrs.weapons.glock = txtrs.weapons.glockr
txtrs.weapons.shortyf = lg.newImage("weapons/shortyf.png")
txtrs.weapons.shortyl = lg.newImage("weapons/shorty_l.png")
txtrs.weapons.shortyr = lg.newImage("weapons/shorty_r.png")
txtrs.weapons.shortyb= lg.newImage("weapons/shorty_b.png")
txtrs.weapons.shorty = txtrs.weapons.shortyr
txtrs.weapons.akl = lg.newImage("weapons/ak_l.png")
txtrs.weapons.akr = lg.newImage("weapons/ak_r.png")
txtrs.weapons.akb = lg.newImage("weapons/ak_b.png")
txtrs.weapons.akf = lg.newImage("weapons/akf.png")
txtrs.weapons.ak = txtrs.weapons.akr
-- other
txtrs.sky1 = lg.newImage("city/sky_day.png")
txtrs.sky2 = lg.newImage("city/sky_night.png")
txtrs.sky = txtrs.sky1
txtrs.logo = lg.newImage("hud/logo.png")
-- | data
data = {}
data.intbox = false -- interaction box
data.intoption1 = {0, 0, 0}
data.intoption2 = {0, 0, 0}
data.intoption3 = {0, 0, 0}
data.intoption4 = {0, 0, 0}
data.lotto = 1000
data.day = 1
data.responce_fd = false
data.responce_pd = false
data.gang1attack = false
data.gang2attack = false
data.gang3attack = false
data.specialevent = false
data.fdtimer = 0
data.pdtimer = 0
data.fdarrived = false
data.fdfinished = false
data.weaponx = 268 -- normal: 268 left correction: 264
data.weapony = 261
data.dayornight = 1
data.moveto = "nil"
data.movingn = false
data.movings = false
data.movinge = false
data.movingw = false
data.walkanim = false
-- | vehs
veh = {}
veh.playercar = {}
veh.playercar.drawx = 300
veh.playercar.drawy = 350
veh.playercar.parkx = 999
veh.playercar.parky = 999
veh.playercar.isparked = true
veh.playercar.speed = 0
veh.playercar.gear = 0 -- (0) park (1+) forward gears (9) reverse
veh.playercar.gears = 5
veh.playercar.ratio = 1
veh.playercar.face = 1
veh.playercar.name = "Police Cruiser"
veh.playercar.hp = 999
veh.playercar.lights = false
veh.playercar.txtr = txtrs.vehs.cruiser1
veh.playercar.rot = 0 -- (up): 0 (down): 3.14 (right): 1.57 (left): 4.71
veh.playercar.angle = 0
veh.playercar.roundstring = "nil"
veh.playercar.rounded = 0
veh.playercar.ycorrector = 0
-- | city
city = {}
city.hood = 9
city.hoodstring = "nil"
city.int = "nil"
city.southeast_txtr = lg.newImage("city/southeast.png") 
-- | graphics
graphics = {}
graphics.npcveh1_txtr = nil
graphics.npcveh1_active = false
graphics.npcveh1_rot = 0.0
graphics.npcveh1_x = -999
graphics.npcveh1_y = -999
graphics.chatfontsize = 6
graphics.font = love.graphics.newImageFont("hud/font.png", " abcdefghijklmnopqrstuvwxyz" .."ABCDEFGHIJKLMNOPQRSTUVWXYZ0" .."123456789.,!?-+/():;%&`'*#=[]\"".."$")
graphics.lightr = 255
graphics.lightg = 255
graphics.lightb = 255
graphics.lightalpha = 255
graphics.timeofday = 0
graphics.timeh = 0
graphics.amorpm = "pm"
graphics.dayornight = "day"
graphics.cyclelength = 9125 -- 1 min = 3650, 2 mins = 7300, 2.4 mins ~ 9125, 3 mins = 10950, 4 mins = 14600, 5 mins = 18250
-- | playerhouse
phouse = {}
phouse.owned = false
phouse.name = "nil"
phouse.hood = "nil"
phouse.weed = 0
phouse.coke = 0
phouse.gun = nil
phouse.plant1 = nil
phouse.plant2 = nil
phouse.plant3 = nil
-- | misc
misc = {}
misc.housedraw = "nil"
-- | msg
msg = {}
msg.colors = {}
msgc = msg.colors
color = msg.colors
msg.colors.rp = {.78, .59, .78}
msg.colors.gray = {.36, .36, .36}
msg.colors.lgray = {.46, .46, .46}
msg.colors.white = {.92, .92, .92}
msg.colors.black = {.15, .15, .15}
msg.colors.lred = {.80, .10, .10}
msg.colors.red = {.60, .10, .10}
msg.colors.dred = {.40, .1, .1}
msg.colors.green = {.20, .90, .15}
msg.colors.lgreen = {0, .88, .25}
msg.colors.blue = {0, .25, .88}
msg.colors.lblue = {.25, .58, .69}
msg.colors.dblue = {0, .98, .50}
msg.colors.yellow = {.78, .78, 0}
msg.colors.purple = {.49, .29, .78}
msg.colors.orange = {0.8, .59, 0}
msg.colors.focus = {1, .65, .65}
msg.line0 = "[0] ..."
msg.line1 = "[1] "
msg.line2 = "[2] ..."
msg.line3 = "[3] ..."
msg.line4 = "[4] ..."
msg.line5 = "[5] ..."
msg.line6 = "[6] ..."
msg.line7 = "[7] ..."
msg.line8 = "[8] Initializing..."
msg.line9 = "[9] StreetzRPG loaded. [v"..n.version.."]"
msg.color0 = msgc.gray; msg.color1 = msgc.white; msg.color2 = msgc.white; msg.color3 = msgc.white; msg.color4 = msgc.white; msg.color5 = msgc.white; msg.color6 = msgc.white; msg.color7 = msgc.white; msg.color8 = msgc.lgray; msg.color9 = msgc.white
msg.box = false
msg.boxmsg = ""
msg.boxchars = 0
msg.boxcordx = 0
msg.boxcordy = 150
-- | audio
audio = {}
audio.mastervolume = 1
audio.smenu = la.newSource("audio/theme.wav", "static")
audio.smenu:setVolume(audio.mastervolume)
audio.smenu:setLooping(true)
audio.smenu:play()
audio.walk = la.newSource("audio/walk.wav", "static")
audio.run = la.newSource("audio/run.wav", "static")
audio.chime = la.newSource("audio/chime.wav", "static")
audio.night = la.newSource("audio/night.wav", "static")
audio.glock = la.newSource("audio/fire_glock.wav", "static")
audio.shorty = la.newSource("audio/fire_shorty.wav", "static")
audio.ak1 = la.newSource("audio/fire_ak_single.wav", "static")
audio.ak2 = la.newSource("audio/fire_ak_auto.wav", "static")
audio.reload_glock = la.newSource("audio/reload_glock.wav", "static")
audio.reload_shorty = la.newSource("audio/reload_shorty.wav", "static")
audio.reload_ak = la.newSource("audio/reload_ak.wav", "static")
audio.noammo = la.newSource("audio/noammo.wav", "static")
audio.sirens = la.newSource("audio/sirens.wav", "static")
-- | factions
fac = {}
fac.pd = {}
fac.pd.rank1 = "Cadet"
fac.pd.rank2 = "Patrol Officer"
fac.pd.rank3 = "Sergeant"
fac.pd.rank4 = "Captain"
fac.pd.rank5 = "Police Chief"
fac.fd = {}
fac.fd.rank1 = "Cadet"
fac.fd.rank2 = "FF/EMT"
fac.fd.rank3 = "Fire Lieutenant"
fac.fd.rank4 = "Battalian Chief"
fac.fd.rank5 = "Fire Chief"
fac.gang = {}
fac.gang.rank1 = "New Blood"
fac.gang.rank2 = "Hood Rat"
fac.gang.rank3 = "Gangsta"
fac.gang.rank4 = "OG"
fac.gang.rank5 = "Hoodlord"
fac.sl = {}
fac.sl.rank1 = "Trainee"
fac.sl.rank2 = "Rookie Trucker"
fac.sl.rank3 = "Senior Trucker"
fac.sl.rank4 = "Foreman"
fac.sl.rank5 = "President"
-- | peds
peds = {} -- farther right on the map = more negative npc coord is
-- {x, y, hp, name, fac, frank, clothes, weapon, holstered, incuffs, wasrobbed, isdrag, race, hasfocus, color, armed}
peds.ped1 = {}
peds.ped1.desc = "NO DESCRIPTION"
peds.ped1.x = 100
peds.ped1.y = 50
peds.ped1.hp = 100
peds.ped1.name = "Javonte Mosely"
peds.ped1.fac = "gang2"
peds.ped1.facrank = 4
peds.ped1.drawnameX = peds.ped1.x - 35
peds.ped1.drawnameY = peds.ped1.y - 25
peds.ped1.drawclothesX = peds.ped1.x + 10
peds.ped1.drawclothesY = peds.ped1.y - 00
peds.ped1.clothes = txtrs.clothes.none
peds.ped1.weapon = txtrs.weapons.glockf
peds.ped1.holstered = true
peds.ped1.incuffs = false
peds.ped1.wasrobbed = false
peds.ped1.isdrag = false
peds.ped1.race = "bma"
peds.ped1.color = color.white
peds.ped1.hasfocus = false
peds.ped1.armed = true
peds.ped2 = {}
peds.ped2.desc = "NO DESCRIPTION"
peds.ped2.x = 150
peds.ped2.y = 50
peds.ped2.hp = 100
peds.ped2.name = "Antonio Moslely"
peds.ped2.fac = "gang2"
peds.ped2.facrank = 5
peds.ped2.drawnameX = peds.ped2.x - 35
peds.ped2.drawnameY = peds.ped2.y - 25
peds.ped2.drawclothesX = peds.ped2.x + 10
peds.ped2.drawclothesY = peds.ped2.y - 00
peds.ped2.clothes = txtrs.clothes.none
peds.ped2.weapon = txtrs.weapons.glockf
peds.ped2.holstered = true
peds.ped2.incuffs = false
peds.ped2.wasrobbed = false
peds.ped2.isdrag = false
peds.ped2.race = "bma"
peds.ped2.color = color.white
peds.ped2.hasfocus = false
peds.ped2.armed = true
peds.ped3 = {}
peds.ped3.desc = "NO DESCRIPTION"
peds.ped3.x = 200
peds.ped3.y = 50
peds.ped3.hp = 100
peds.ped3.name = "James Hucken"
peds.ped3.fac = "pd"
peds.ped3.facrank = 3
peds.ped3.drawnameX = peds.ped3.x - 35
peds.ped3.drawnameY = peds.ped3.y - 25
peds.ped3.drawclothesX = peds.ped3.x + 10
peds.ped3.drawclothesY = peds.ped3.y - 00
peds.ped3.clothes = txtrs.clothes.none
peds.ped3.weapon = txtrs.weapons.glockf
peds.ped3.holstered = true
peds.ped3.incuffs = false
peds.ped3.wasrobbed = false
peds.ped3.isdrag = false
peds.ped3.race = "wma"
peds.ped3.color = color.white
peds.ped3.hasfocus = false
peds.ped3.armed = true
peds.ped4 = {}
peds.ped4.desc = "NO DESCRIPTION"
peds.ped4.x = 250
peds.ped4.y = 50
peds.ped4.hp = 100
peds.ped4.name = "Isaiah Freeman"
peds.ped4.fac = "gang2"
peds.ped4.facrank = 3
peds.ped4.drawnameX = peds.ped4.x - 35
peds.ped4.drawnameY = peds.ped4.y - 25
peds.ped4.drawclothesX = peds.ped4.x + 10
peds.ped4.drawclothesY = peds.ped4.y - 00
peds.ped4.clothes = txtrs.clothes.none
peds.ped4.weapon = txtrs.weapons.glockf
peds.ped4.holstered = true
peds.ped4.incuffs = false
peds.ped4.wasrobbed = false
peds.ped4.isdrag = false
peds.ped4.race = "bma"
peds.ped4.color = color.white
peds.ped4.hasfocus = false
peds.ped4.armed = true
peds.ped5 = {}
peds.ped5.desc = "NO DESCRIPTION"
peds.ped5.x = 300
peds.ped5.y = 50
peds.ped5.hp = 100
peds.ped5.name = "Veronica Alexandra"
peds.ped5.fac = "pd"
peds.ped5.facrank = 2
peds.ped5.drawnameX = peds.ped5.x - 35
peds.ped5.drawnameY = peds.ped5.y - 25
peds.ped5.drawclothesX = peds.ped5.x + 5
peds.ped5.drawclothesY = peds.ped5.y + 5
peds.ped5.clothes = txtrs.clothes.none
peds.ped5.weapon = txtrs.weapons.shortyr
peds.ped5.holstered = true
peds.ped5.incuffs = false
peds.ped5.wasrobbed = false
peds.ped5.isdrag = false
peds.ped5.race = "wfa"
peds.ped5.color = color.white
peds.ped5.hasfocus = false
peds.ped5.armed = true
peds.ped6 = {}
peds.ped6.desc = "NO DESCRIPTION"
peds.ped6.x = 350
peds.ped6.y = 50
peds.ped6.hp = 100
peds.ped6.name = "Henry Smith"
peds.ped6.fac = "civilian"
peds.ped6.facrank = 0
peds.ped6.drawnameX = peds.ped6.x - 35
peds.ped6.drawnameY = peds.ped6.y - 25
peds.ped6.drawclothesX = peds.ped6.x + 10
peds.ped6.drawclothesY = peds.ped6.y - 00
peds.ped6.clothes = txtrs.clothes.none
peds.ped6.weapon = txtrs.weapons.glockf
peds.ped6.holstered = true
peds.ped6.incuffs = false
peds.ped6.wasrobbed = false
peds.ped6.isdrag = false
peds.ped6.race = "wma"
peds.ped6.color = color.white
peds.ped6.hasfocus = false
peds.ped6.armed = true
peds.ped7 = {}
peds.ped7.desc = "NO DESCRIPTION"
peds.ped7.x = 400
peds.ped7.y = 50
peds.ped7.hp = 100
peds.ped7.name = "Darren Thompson"
peds.ped7.fac = "civilian"
peds.ped7.facrank = 0
peds.ped7.drawnameX = peds.ped7.x - 35
peds.ped7.drawnameY = peds.ped7.y - 25
peds.ped7.drawclothesX = peds.ped7.x + 10
peds.ped7.drawclothesY = peds.ped7.y - 00
peds.ped7.clothes = txtrs.clothes.none
peds.ped7.weapon = txtrs.weapons.glockf
peds.ped7.holstered = true
peds.ped7.incuffs = false
peds.ped7.wasrobbed = false
peds.ped7.isdrag = false
peds.ped7.race = "wma"
peds.ped7.color = color.white
peds.ped7.hasfocus = false
peds.ped7.armed = true
peds.ped7.fac = "civilian"
peds.ped7.facrank = 0
peds.ped8 = {}
peds.ped8.desc = "NO DESCRIPTION"
peds.ped8.x = 450
peds.ped8.y = 50
peds.ped8.hp = 100
peds.ped8.name = "Ashley Vindago"
peds.ped8.fac = "gang3"
peds.ped8.facrank = 0
peds.ped8.drawnameX = peds.ped8.x - 35
peds.ped8.drawnameY = peds.ped8.y - 25
peds.ped8.drawclothesX = peds.ped8.x + 10
peds.ped8.drawclothesY = peds.ped8.y - 00
peds.ped8.clothes = txtrs.clothes.none
peds.ped8.weapon = txtrs.clothes.none
peds.ped8.holstered = nil
peds.ped8.incuffs = false
peds.ped8.wasrobbed = false
peds.ped8.isdrag = false
peds.ped8.race = "hfa"
peds.ped8.color = color.white
peds.ped8.hasfocus = false
peds.ped8.armed = false
peds.ped9 = {}
peds.ped9.desc = "NO DESCRIPTION"
peds.ped9.x = 500
peds.ped9.y = 50
peds.ped9.hp = 100
peds.ped9.name = "Gary West"
peds.ped9.fac = "civilian"
peds.ped9.facrank = 0
peds.ped9.drawnameX = peds.ped9.x - 35
peds.ped9.drawnameY = peds.ped9.y - 25
peds.ped9.drawclothesX = peds.ped9.x + 10
peds.ped9.drawclothesY = peds.ped9.y - 00
peds.ped9.clothes = txtrs.clothes.none
peds.ped9.weapon = txtrs.clothes.none
peds.ped9.holstered = nil
peds.ped9.incuffs = false
peds.ped9.wasrobbed = false
peds.ped9.isdrag = false
peds.ped9.race = "wma"
peds.ped9.color = color.white
peds.ped9.hasfocus = false
peds.ped9.armed = false
peds.ped0 = {}
peds.ped0.desc = "NO DESCRIPTION"
peds.ped0.x = 550
peds.ped0.y = 50
peds.ped0.hp = 100
peds.ped0.name = "Jason Diego"
peds.ped0.fac = "gang3"
peds.ped0.facrank = 0
peds.ped0.drawnameX = peds.ped0.x - 35
peds.ped0.drawnameY = peds.ped0.y - 25
peds.ped0.drawclothesX = peds.ped0.x + 10
peds.ped0.drawclothesY = peds.ped0.y - 0
peds.ped0.clothes = txtrs.clothes.none
peds.ped0.weapon = txtrs.weapons.glockf
peds.ped0.holstered = true
peds.ped0.incuffs = false
peds.ped0.wasrobbed = false
peds.ped0.isdrag = false
peds.ped0.race = "hma"
peds.ped0.color = color.white
peds.ped0.hasfocus = false
peds.ped0.armed = true
n.deadped = peds.ped0
peds.emt = {}
peds.emt.x = 0
peds.emt.y = 0
peds.cop = {}
peds.cop.x = 0
peds.cop.y = 0
peds.cop.txtr = txtrs.skins.cop1f
peds.cop.txtrf = txtrs.skins.cop1f
peds.cop.txtrb = txtrs.skins.cop1b
facdir = fac
-- start menu data
n.sdata = {}
n.sdata.option = 1 -- (1) play (2) settings (3) quit
n.sdata.driftspeed = 1 -- world can be hazy if set to 0.25, need to round decimal to quarter intervals
n.sdata.driftmax = 500
n.sdata.driftx = 0
n.sdata.drifty = 0
n.sdata.drift = 0
n.sdata.dodrift = true
n.sdata.opperatorx = 1 -- (1) + (2) -
n.sdata.opperatory = 1
n.sdata.light = 1
n.sdata.fade = 1 -- (0) from black (1) to black
n.sdata.intermission = false
n.sdata.dayornight = 0
n.sdata.color1 = msg.colors.white
n.sdata.color2 = msg.colors.white
n.sdata.color3 = msg.colors.white
n.sdata.on1 = false
n.sdata.on2 = false
n.sdata.on3 = false
n.sdata.settings = false
n.sdata.play = false
n.sdata.playon1 = false
n.sdata.playon2 = false
n.sdata.playon3 = false
n.sdata.playonaccept = false
n.sdata.playcoloraccept = msg.colors.white
n.sdata.setcoloraccept = msg.colors.white
n.sdata.setonaccept = false
n.sdata.setcolor10 = msg.colors.white -- (1X): controls (2X): graphics (3X): dev tools
n.sdata.setcolor11 =  msg.colors.white
n.sdata.setcolor12 =  msg.colors.white
n.sdata.setcolor13 =  msg.colors.white
n.sdata.setcolor14 =  msg.colors.white
n.sdata.setcolor15 =  msg.colors.white
n.sdata.setcolor16 =  msg.colors.white
n.sdata.setcolor17 =  msg.colors.white
n.sdata.setcolor18 =  msg.colors.white
n.sdata.setcolor19a =  msg.colors.white
n.sdata.setcolor19b =  msg.colors.white
n.sdata.setcolor30 =  msg.colors.white
n.sdata.setcolor31 =  msg.colors.white
n.sdata.setcolor32 =  msg.colors.white
n.sdata.seton11 = false
n.sdata.seton12 = false
n.sdata.seton13 = false
n.sdata.seton14 = false
n.sdata.seton15 = false
n.sdata.seton16 = false
n.sdata.seton17 = false
n.sdata.seton18 = false
n.sdata.seton19a = false
n.sdata.seton19b = false
n.sdata.seton30 = false
n.sdata.seton31 = false
n.sdata.seton32 = false
n.sdata.input = false
n.sdata.inputcode = 999
-- animation
anim = {}
anim.walk = 0
anim.walkmax = 15
anim.walkphase = 0
anim.dowalkdown = false
anim.dowalkup = false
anim.sprites = {}
anim.sprites.pskin = newAnimation(lg.newImage("skins/sprite/swat1f.png"), 40, 65, 1) -- moving dn
anim.sprites.pskin2 = newAnimation(lg.newImage("skins/sprite/swat1b.png"), 40, 65, 1) -- moving up
anim.sprites.pskin3 = newAnimation(lg.newImage("skins/sprite/swat1.png"), 40, 65, 15) -- idle
anim.sprites.ped0 = newAnimation(lg.newImage("skins/sprite/blue1.png"), 40, 65, 150)
anim.sprites.ped1 = newAnimation(lg.newImage("skins/sprite/green2.png"), 40, 65, 150)
anim.sprites.ped2 = newAnimation(lg.newImage("skins/sprite/green2.png"), 40, 65, 150)
anim.sprites.ped3 = newAnimation(lg.newImage("skins/sprite/cop3.png"), 40, 65, 150)
anim.sprites.ped4 = newAnimation(lg.newImage("skins/sprite/green3.png"), 40, 65, 150)
anim.sprites.ped5 = newAnimation(lg.newImage("skins/sprite/cop4.png"), 40, 65, 150)
anim.sprites.ped6 = newAnimation(lg.newImage("skins/sprite/civ1.png"), 40, 65, 150)
anim.sprites.ped7 = newAnimation(lg.newImage("skins/sprite/civ2.png"), 40, 65, 150)
anim.sprites.ped8 = newAnimation(lg.newImage("skins/sprite/civ3.png"), 40, 65, 150)
anim.sprites.ped9 = newAnimation(lg.newImage("skins/sprite/civ1.png"), 40, 65, 150)
anim.sprites.pedEMT = newAnimation(lg.newImage("skins/sprite/emt1.png"), 40, 65, 1)
anim.spriteNum = 0
anim.spriteNum2 = 0
anim.spriteNum3 = 0
anim.p0spriteNum = 0
anim.p1spriteNum = 0
anim.p2spriteNum = 0
anim.p3spriteNum = 0
anim.p4spriteNum = 0
anim.p5spriteNum = 0
anim.p6spriteNum = 0
anim.p7spriteNum = 0
anim.p8spriteNum = 0
anim.p9spriteNum = 0
anim.pEMTspriteNum = 0
n.animpath = anim.sprites.ped0
-- libraries
cscript = require("cscript")
smenu = require("smenu")
sjob = require("sjob")
sets = {} -- default settings
sets.move_up = 'w'
sets.move_dn = 's'
sets.move_lt = 'a'
sets.move_rt = 'd'
sets.fire = 'space'
sets.sprint = 'lshift'
sets.upshift = 'up'
sets.dnshift = 'down'
sets.enter = 'y'
sets.exit = 'h'
sets.car = 'f'
sets.msgbox = 't'
sets.accept = 'return'
sets.reload = 'r'
sets.devmode = false
sets.cmdblist = false
config = love.filesystem.load("config.lua")
event = require("event")
pedlist = require("pedlist")
vehdata = require("vehdat")
lf.load("sav1.lua")
-- misc
n.devmode = false
n.devtags = false
n.initalized = false
n.npcpath = peds.ped0
n.npcpath2 = peds.ped0 -- for cop updating
n.npcpathid = 0
n.npcpathid2 = 0
n.smenu = true
n.mousex = 0
n.mousey = 0
n.buying = nil
n.selltocopauth = false
n.devcopy = true -- TODO: SET TO FALSE FOR PUBLIC RELEASE
n.cheats = {}
n.cheats.fullclip = false
--| shortcuts
player = player
txtrs = txtrs
inv = inv
msg = msg
color = msg.colors
fac = fac
ped = peds
world = world
graphics = graphics
perks = perks
city = city
vehs = vehs
smenu = smenu
audio = audio
print("[LOADED] main.lua\n")
if n.devcopy == true then
append(color.lblue, "Welcome, LOVE forum user!")
append(color.red, "WARNING: Playing developmental version of game!")
end

if n.smenu == true then smenu.update() smenu.draw() end
end -- end of love.load

-- MARKER SYSTEM
function marker_new(ecks, why, style, hood)
		n.marker.pos_x = ecks; n.marker.pos_y = why
		n.marker.tpos_x = ecks; n.marker.tpos_y = why
		if style == 1 then n.marker.style = txtrs.marker1 end -- go to x, then despawns or moves
		n.marker.active = true
		n.marker.hood = hood
		print("[marker_new] New marker at "..n.marker.pos_x..", "..n.marker.pos_y.." in hood id "..hood..".")
end

function marker_entered()
	if player.job_active == true then -- TODO: add arguments for other sjobs
		jdata.finish(1, "pizza")
		player.job_active = false
	end
	n.marker.pos_x = -999
	n.marker.pos_y = -999
	n.marker.draw = false
	n.marker.hood = 0
	print("[marker_entered] Marker was entered, removing.")
end

function marker_check()
	print("[marker_check] Function ran!")
	local match = false
		if n.marker.hood == 1 and city.hood == 1 then match = true end
		if n.marker.hood == 2 and city.hood == 2 then match = true end
		if n.marker.hood == 3 and city.hood == 3 then match = true end
		if n.marker.hood == 4 and city.hood == 4 then match = true end
		if n.marker.hood == 5 and city.hood == 5 then match = true end
		if n.marker.hood == 6 and city.hood == 6 then match = true end
		if n.marker.hood == 7 and city.hood == 7 then match = true end
		if n.marker.hood == 8 and city.hood == 8 then match = true end
		if n.marker.hood == 9 and city.hood == 9 then match = true end
		if match == false then print("! [marker_check] Marker hood does not match; marker will not draw."); n.marker.draw = false end
		if match == true then print("! [marker_check] Marker will draw."); n.marker.draw = true end
end

function crosshair(toggle)
	if toggle == true then love.mouse.setCursor(love.mouse.newCursor("hud/site1.png", 0, 0)) end
	if toggle == false then love.mouse.setCursor(love.mouse.getSystemCursor("arrow"), 0, 0) end
end

function wanted(status)
	if status == true then
		append(color.red, "You hear sirens in the distance!")
		player.wanted = true; audio.sirens:play();
	end
	if status == false then
		player.wanted = false
	end
end

function catchfish()
	local catch = love.math.random(1,2)
	if catch == 1 then
		local catchjunk = love.math.random(1,5)
		local junk = nil
		if catchjunk == 1 then junk = "a boot" end
		if catchjunk == 2 then junk = "a flat tire" end
		if catchjunk == 3 then junk = "some seaweed" end
		if catchjunk == 4 then junk = "some kelp" end
		if catchjunk == 5 then junk = "a soda can" end
		append(color.blue, "You reel in "..junk..".")
		player.clothes.torso = txtrs.clothes.none; player.clothes.torsoX = player.x
	end
	if catch == 2 then
		inv.bait.qnty = inv.bait.qnty - 1
		local catchcommon = love.math.random(1,4)
		local catchbreed = nil
		local catchweight = love.math.random(1,25)
		local breed = nil
		if catchcommon == 3 then catchbreed = love.math.random(5,10) else catchbreed = love.math.random(1,5) end
		if catchbreed <= 5 then append(color.green, "Common catch!") end
		if catchbreed >= 6 and catchbreed < 9 then append(color.orange, "Uncommon catch!") end
		if catchbreed >= 9 then append(color.red, "Rare catch!") end
		if catchbreed == 1 then breed = "cod" end -- FISH IDs / VALUE
		if catchbreed == 2 then breed = "salmon" end
		if catchbreed == 3 then breed = "bass" end
		if catchbreed == 4 then breed = "trout" end
		if catchbreed == 5 then breed = "pike" end
		if catchbreed == 6 then breed = "walleye" end
		if catchbreed == 7 then breed = "pufferfish" end
		if catchbreed == 8 then breed = "eel" end
		if catchbreed == 9 then breed = "squid" end
		if catchbreed == 10 then breed = "shark" end
		append(color.blue, "You catch a "..catchweight.." lb "..breed..", and add it to your /bucket.")
		inv.frod.hp = inv.frod.hp - love.math.random(1,3)
		if inv.frod.hp <= 0 then append(color.red, "Your rod has snapped from stress!"); inv.frod.has = false; inv.frod.hp = 0 end
		if catchbreed <= 5 then xp(1) end
		if catchbreed >= 6 and catchbreed < 9 then xp(2) end
		if catchbreed >= 9 then xp(3) end
		player.clothes.torso = txtrs.clothes.none; player.clothes.torsoX = player.x
		if inv.fbucket.slot1_weight <= 0 then inv.fbucket.slot1_weight = catchweight; inv.fbucket.slot1_breed = breed; inv.fbucket.slot1_worth = catchbreed; return end
		if inv.fbucket.slot2_weight <= 0 then inv.fbucket.slot2_weight = catchweight; inv.fbucket.slot2_breed = breed; inv.fbucket.slot2_worth = catchbreed; return end
		if inv.fbucket.slot3_weight <= 0 then inv.fbucket.slot3_weight = catchweight; inv.fbucket.slot3_breed = breed; inv.fbucket.slot3_worth = catchbreed;return end
		if inv.fbucket.slot4_weight <= 0 then inv.fbucket.slot4_weight = catchweight; inv.fbucket.slot4_breed = breed; inv.fbucket.slot4_worth = catchbreed; return end
		if inv.fbucket.slot5_weight <= 0 then inv.fbucket.slot5_weight = catchweight; inv.fbucket.slot5_breed = breed; inv.fbucket.slot5_worth = catchbreed; return end
	end
end

function xp(amount)
	player.xp = player.xp + amount
	append(color.green, "You earned "..amount.." XP.")
	if player.xp >= player.maxxp then
		player.lvl = player.lvl + 1
		player.xp = 0; player.maxxp = player.lvl * 10
		append(color.lgreen, "You leveled up! "..player.maxxp.." XP to next level up.")
	end
end

function selldrug(drug, amount)
	if drug == "coke" then
		if inv.coke.qnty >= amount then 
			if player.pricecoke <= 120 then
				player.cash = player.cash + (amount * player.pricecoke)
				if amount == 1 then append(color.lgreen, "You have sold 1 gram of coke for $"..player.pricecoke.."!") end
				if amount > 1 then append(color.lgreen, "You have sold "..amount.." grams of coke for $"..amount * player.pricecoke.."!") end
				xp(amount / 2) -- 0.5 xp per gram sold
				n.canselldrug = false
				inv.coke.qnty = inv.coke.qnty - amount
			else append(color.white, n.npcpath.name..": Ouch. $"..player.pricecoke.." a gram!? No thanks, actually."); n.canselldrug = false
			end
		end
	end
	if drug == "weed" then
		if inv.weed.qnty >= amount then
			if player.priceweed <= 30 then
				player.cash = player.cash + (amount * player.priceweed)
				if amount == 1 then append(color.lgreen, "You have sold 1 gram of weed for $"..player.priceweed.."!") end
				if amount > 1 then append(color.lgreen, "You have sold "..amount.." grams of weed for $"..amount * player.priceweed.."!") end
				xp(amount / 2) -- 0.5 xp per gram sold
				n.canselldrug = false
				inv.weed.qnty = inv.weed.qnty - amount
			else append(color.white, n.npcpath.name..": Ouch. $"..player.priceweed.." a gram!? No thanks, actually."); n.canselldrug = false
			end
		end
	end
end

function buydrug(drug, amount)
local cokerate = 100
local weedrate = 20
	if player.factionid == 1 then cokerate = 200; weedrate = 40 end
local cost = nil
	if drug == "coke" and amount ~= nil then
		cost = (amount * cokerate)
		if player.cash - cost < 0 then append(color.gray, "You do not have enough money ($"..cost..") to buy "..amount.." grams of coke."); return end
		if player.cash - cost >= 0 then 
			inv.coke.qnty = inv.coke.qnty + amount
			player.cash = player.cash - cost
			append(color.red, "You buy "..amount.."g of coke from the dealer for $"..cost..".")
			local gbmsg = love.math.random(1,3)
			local bulksave = (amount * love.math.random(1,8))
			if gbmsg == 1 then append(color.white, n.npcpath.name..": Pleasure doin' business.") end
			if gbmsg == 2 then append(color.white, n.npcpath.name..": I've always got more on deck.") end
			if gbmsg == 3 then append(color.white, n.npcpath.name..": Party on!") end
			if amount >= 28 then append(color.lgreen, "You saved $"..bulksave.." by buying in bulk!"); player.cash = player.cash + bulksave end
			n.buying = nil
		end
	end
	if drug == "weed" and amount ~= nil then
		cost = (amount * weedrate)
		if player.cash - cost < 0 then append(color.gray, "You do not have enough money ($"..cost..") to buy "..amount.." grams of weed."); return end
		if player.cash - cost >= 0 then 
		inv.weed.qnty = inv.weed.qnty + amount
		player.cash = player.cash - cost
		append(color.red, "You buy "..amount.."g of weed from the dealer for $"..cost..".")
		local gbmsg = love.math.random(1,3)
		local bulksave = (amount * love.math.random(1,4))
		if gbmsg == 1 then append(color.white, n.npcpath.name..": Tell me whatcha' think of this new strain.") end
		if gbmsg == 2 then append(color.white, n.npcpath.name..": That's some mad sticky-icky.") end
		if gbmsg == 3 then append(color.white, n.npcpath.name..": Roll a jay of this, and call me from SPACE!") end
		if amount >= 28 then append(color.lgreen, "You saved $"..bulksave.." by buying in bulk!"); player.cash = player.cash + bulksave end
		n.buying = nil 
		end
	end
	n.talkingto = nil
end

function doffmsg(ffshoutmsg)
	if ffshoutmsg == 1 then append(color.orange, n.npcpath.name..": WATCH YOUR FIRE!") end
	if ffshoutmsg == 2 then append(color.orange, n.npcpath.name..": WOAH! HOLD FIRE, HOLD FIRE!") end
	if ffshoutmsg == 3 then append(color.orange, n.npcpath.name..": CHECK YOUR AIM!") end
end

function summon(npc)
	if npc == "emt" then
		data.responce_fd = true
		append(color.gray, "[summon] Summoning EMT...")
		data.emsrespond = true
		ped.emt.x = 250
		ped.emt.y = -100
		anim.sprites.pedEMT = newAnimation(lg.newImage("skins/sprite/emt1f.png"), 40, 65, 50)
	end
	if npc == "cop" then
		data.responce_pd = true
		append(color.gray, "[summon] Summoning cop...")
		data.pdrespond = true
		ped.cop.x = 250
		ped.cop.y = -100
		ped.cop.txtrf = txtrs.skins.cop1f; ped.cop.txtrb = txtrs.skins.cop1b; ped.cop.txtr = ped.cop.txtrf
	end
end

function playerhit(dmg)
if n.npcpath.incuffs == true then return end
local hadarmor = false
local hasarmor = false
local updated = false
local crit = love.math.random(1,10)
checkproxi()
if n.canX == true and n.canY == true then
	if n.npcpath.weapon == txtrs.weapons.glockf then audio.glock:play() elseif n.npcpath.weapon == txtrs.weapons.shortyr then audio.shorty:play() end
	if crit == 10 then dmg = dmg * 2
		append(color.dred, "[CRIT!] You take "..dmg.." points of damage!")
	end
	if player.ap <= 0 then
		hasarmor = false
		player.hp = player.hp - dmg
		append(color.lred, ("You get hit for "..dmg.." damage!"))
		if player.clothes.gore == txtrs.clothes.shot1 then player.clothes.gore = txtrs.clothes.shot2 elseif player.clothes.gore == txtrs.clothes.none then player.clothes.gore = txtrs.clothes.shot1 end
		player.clothes.goreX = player.x; player.clothes.goreY = player.y
		updated = true
	end
	if player.ap > 0 then
		hadarmor = true
		player.ap = player.ap - dmg
		append(color.lred, ("Your vest is hit for "..dmg.." damage!"))
		updated = true
	end
	if updated == true and player.ap <= 0 then
--		player.clothes.torso = txtrs.clothes.none; player.clothes.torso_f = txtrs.clothes.none; player.clothes.torso_b = txtrs.clothes.none
		if player.ap < 0 then
			local remainingdmg = 0 - player.ap
			player.hp = player.hp - remainingdmg
		end
		hasarmor = false
	end
	if updated == true and player.hp >= 90 then player.hpcolor = color.lgreen end
	if updated == true and player.hp > 50 and player.hp < 90 then player.hpcolor = color.green end
	if updated == true and player.hp < 50 and player.hp >= 25 then player.hpcolor = color.yellow end
	if updated == true and player.hp < 25 then player.hpcolor = color.red end
	if updated == true and hasarmor == false and player.hp <= 10 then
		player.canmove = false
		player.speed = 0
		player.isdown = true
		local killreaction = love.math.random(1,3)
		if killreaction == 1 then append(color.white, n.npcpath.name..": Bitch ass...") end
		if killreaction == 2 then append(color.white, n.npcpath.name..": That's what you get, fucker!") end
		if killreaction == 3 then append(color.rp, n.npcpath.name.." spits on your body as you start to bleed out.") end -- TODO: make dynamic with ped race/faction
		append(color.red, ("You have been downed. You need medical attention or you will die!"))
		player.wanted = false
		summon("emt")
		player.deaths = player.deaths + 1
		graphics.hpcolor = color.red
		player.canmove = false; player.speed = 0; player.isdown = true
		append(color.dred, "[Stats] +1 death!")
		player.clothes.gore = txtrs.clothes.gore
		player.clothes.goreX = player.x; player.clothes.goreY = player.y
		player.hpcolor = color.red
		player.hp = 10
	end
	if updated == true and player.hp <= 0 then append(color.dred, "You have died!"); player.canmove = false; player.speed = 0 end
end
end

function checkdead(todeal)
	if n.npcpath.hp - todeal <= 0 then append(color.rp, n.npcpath.name.." has been killed!"); updatenpcs(); return end
end

function targethit(dmg)
	local ff = false
	if n.npcpath.fac == "pd" and player.factionid == 1 then ff = true end
	if player.isdown == false then
		local crit = love.math.random(1,10) -- CRIT CHANCE
		checkproxi()
		if n.npcpath.hasfocus == false then append(color.gray, "You missed!"); return end
		if n.canX == true and n.canY == true then
		if crit == 10 and dmg ~= nil then dmg = dmg * 2
			append(color.purple, "[CRIT!] You deal "..dmg.." points of damage!")
		end
		if n.npcpath.fac == "pd" and player.factionid ~= 1 then player.wanted = true -- set wanted (if ped is a cop and player is not)
			local backup = love.math.random(1,3)
				if backup == 3 then
					append(color.red, "You hear sirens in the distance!"); player.wanted = true
			end
		end
		if n.npcpath.hp <= 0 then
			append(color.gray, n.npcpath.name.." is already dead.")
			if player.wanted == true and n.npcpath.fac == "pd" then n.deadped = n.npcpath end
			return
		end
	weaponfired()
		end
		if n.npcpath.hp >= -1 then
			if dmg ~= nil then n.npcpath.hp = n.npcpath.hp - dmg end
			if dmg == nil then return end
			append(color.rp, n.npcpath.name.." is hit for "..dmg.." damage!")
			--event.new(6)
			n.dmgind = dmg
			n.npcpath.drawclothesX = n.npcpath.x; n.npcpath.drawclothesY = n.npcpath.y
			if n.npcpath.hp <= 75 and n.npcpath.hp >= 50 then n.npcpath.clothes = txtrs.clothes.shot1 end
			if n.npcpath.hp < 50 and n.npcpath.hp > 15 then n.npcpath.clothes = txtrs.clothes.shot2 end
			if n.npcpath.hp <= 15 then n.npcpath.clothes = txtrs.clothes.gore end
			n.npcpath.drawclothesX = n.npcpath.x
			if n.npcpath.armed == true then
				if n.npcpath.incuffs == false then
				if ff == true then doffmsg(love.math.random(1,3)) end
				if n.hasshown == false and n.npcpath.weapon == txtrs.weapons.glockf and ff == false then append(color.rp, n.npcpath.name.." withdraws their 9mm Pistol and takes aim."); n.npcpath.holstered = false; n.hasshown = true; return end
				if n.hasshown == false and n.npcpath.weapon == txtrs.weapons.shortyr and ff == false then append(color.rp, n.npcpath.name.." raises their Super Shorty and takes aim."); n.npcpath.holstered = false; n.hasshown = true; return end
				elseif n.npcpath.incuffs == true then print("[targethit] ped has gun but is cuffed!")
				end
			end -- end of if ped is not in cuffs
		if n.npcpath.hp <= 0 and n.npcpath.hp >= -999 then
			checkdead(dmg)
			if player.wanted == true and n.npcpath.fac == "pd" then n.deadped = n.npcpath end
			n.npcpath.clothes = txtrs.clothes.gore
			n.npcpath.drawclothesX = n.npcpath.x
			n.npcpath.drawclothesY = n.npcpath.y
			n.npcpath.armed = false
			n.npcpath.hp = -999
			player.kills = player.kills + 1
			local bonusxp = false
			if player.factionid == 1 and (n.npcpath.fac == "gang1" or n.npcpath.fac == "gang2" or n.npcpath.fac == "gang3") then xp(4); bonusxp = true end
			if player.factionid == 3 and (n.npcpath.fac == "gang2" or n.npcpath.fac == "gang3" or n.npcpath.fac == "pd") then xp(4); bonusxp = true end
			if player.factionid == 4 and (n.npcpath.fac == "gang1" or n.npcpath.fac == "gang3" or n.npcpath.fac == "pd") then xp(4); bonusxp = true end
			if player.factionid == 5 and (n.npcpath.fac == "gang1" or n.npcpath.fac == "gang2" or n.npcpath.fac == "pd") then xp(4); bonusxp = true end
			if bonusxp == false then xp(2) end
			append(color.lgreen, "[Stats] +1 kill!")
		end
		if n.npcpath.hp > 0 and n.npcpath.armed == true and ff == false then
			local npcaccuracy = love.math.random(1, 3)
			if npcaccuracy == 3 then
					if n.npcpath.incuffs == false then
						append(color.rp, "You dodge "..n.npcpath.name.."'s bullet!")
					end
			else if n.npcpath.incuffs == false then playerhit(love.math.random(10, 30)) end
			end
		end
	elseif player.hp <= 10 then append(color.gray, "You cannot engage in combat if you are downed.")
	end -- end of if not downed
end -- end of targethit()
end

function weaponfired()
	if player.weapons.selected == "glock" then
			if audio.glock:isPlaying() ~= true then
				if player.weapons.clip1 >= 1 then
					player.weapons.clip1 = player.weapons.clip1 - 1
					audio.glock:play()
				elseif player.weapons.clip1 < 1 and (audio.glock:isPlaying() == false) then append(color.gray, "Your magazine is empty!"); return
				end
			else return
			end
		end
		if player.weapons.selected == "shorty" then
			if audio.shorty:isPlaying() ~= true then
				if player.weapons.clip2 >= 1 then
					player.weapons.clip2 = player.weapons.clip2 - 1
					audio.shorty:play()
				elseif player.weapons.clip2 < 1 and (audio.shorty:isPlaying() == false) then append(color.gray, "Your magazine is empty!"); return
				end
			else return
			end
		end
		if player.weapons.selected == "ak" then
			if audio.ak1:isPlaying() ~= true then
				if player.weapons.clip3 >= 3 then
					player.weapons.clip3 = player.weapons.clip3 - 3
					audio.ak1:play()
			elseif player.weapons.clip3 < 3 and (audio.ak1:isPlaying() == false) then append(color.gray, "Your magazine is empty!"); return
				end
			else return
			end
end

end

function update()
function love.update(dt)
-- is wanted
if svc.wantedtimer < svc.wantedtimermax then
	svc.wantedtimer = svc.wantedtimer + 1
	updatetags(); updatenpcs();
else
	if player.wanted == true then
		wantedupdate()
		local cophasaim = love.math.random(1,4)
		if cophasaim == 3 then playerhit(love.math.random(10, 20)) end
		if n.deadped ~= nil then
			n.deadped.hp = 200
			n.deadped.x = love.math.random(500, 1000); n.deadped.y = love.math.random(500, 1000); n.deadped.armed = true; n.deadped.holstered = false n.deadped.clothes = txtrs.clothes.none; append(color.red, "Police reinforcements arrive in the distance!");  ped.name = pedlist.pd[4]audio.sirens:play(); 		updatetags(); updatenpcs(); n.deadped = nil
		end
	end
	svc.wantedtimer = 0
end
-- actual time updater
	if true then
	local newh = math.floor(graphics.timeofday / 760) -- 12 sec "hours" ~ 760  ticks
	graphics.timeh = newh
	end
-- dialog color updater
	if dialog.active == true then
		if n.mousex >= 100 and n.mousex <= 500 then
			if (n.mousey >= 325 and n.mousey <= 350) then dialog.colors = {1, 0, 0} end -- option1 active
			if n.mousey >= 375 and n.mousey <= 400 then dialog.colors = {0, 1, 0} end -- option2 active
			if n.mousey >= 425 and n.mousey <= 450 then dialog.colors  = {0, 0, 1} end -- option3 active		
			else dialog.colors = {0, 0, 0}
		end
	end
-- interaction box color handler
	if data.intbox == true then
		local mpos = {n.mousex, n.mousey}
		local rpos = {n.npcpath.x, n.npcpath.y}
		if ((mpos[1] >= rpos[1] + 50 and mpos[1] < rpos[1] + 150) and (mpos[2] >= rpos[2] and mpos[2] < rpos[2] + 150)) then
			data.intoption1 = {1, 0, 0}
			data.intoption2 = {0, 1, 0}
			data.intoption3 = {0, 0, 1}
			data.intoption4 = {1, 1, 1}
		else data.intoption1 = color.white; data.intoption2 = color.white; data.intoption3 = color.white; data.intoption4 = color.white
		end
		
		
	end
-- event handler
	if event.doupdate == true then
				if event.eventcode == "drivewait" then
					if event.timer < event.timer_max then
					if event.arg1 == 1 then graphics.npcveh1_y = graphics.npcveh1_y - event.arg2; graphics.npcveh1_rot = 0 end
					if event.arg1 == 2 then graphics.npcveh1_y = graphics.npcveh1_y+ event.arg2; graphics.npcveh1_rot = 3.14 end
					if event.arg1 == 3 then graphics.npcveh1_x = graphics.npcveh1_x + event.arg2; graphics.npcveh1_rot = 1.57 end
					if event.arg1 == 4 then graphics.npcveh1_x = graphics.npcveh1_x - event.arg2; graphics.npcveh1_rot = -1.57 end
						event.timer = event.timer + 1
						return event.timer
					end
				if event.timer >= event.timer_max then
					print("[event] EVENT FINISHED!")
					graphics.npcveh1_x = -999
					graphics.npcveh1_y = -999
					graphics.npcveh1_rot = 0
					graphics.npcveh1_active = false
					event.eventcode = "nil"; event.doupdate = false
				end
			end
			if event.eventcode == "fishwait" then
				if event.timer < event.timer_max then
					event.timer = event.timer + 1
					return
				end
				if event.timer >= event.timer_max then
					print("[event] EVENT FINISHED!"); catchfish(); event.eventcode = "nil"; event.doupdate = false
				end
			end
			if event.eventcode == "arrestflee" then
				if event.timer < event.timer_max then
						event.timer = event.timer + 1
				end
				if event.leftorright == "left" then
					getpath2(event.ped)
					if n.npcpath2.x > event.arg1 then
						n.npcpath2.x = n.npcpath2.x - 3
						updatetags()
						updatenpcs()
					end
				end
			end
			if event.eventcode == "copupdate-a" then			
			n.actuallyquickgascop = false
				if event.timer < event.timer_max then
						event.timer = event.timer + 1
					end
					if event.timer >= event.timer_max then					
						if event.leftorright == "left" then
							getpath2(event.ped)
							if n.npcpath2.x > event.arg1 then -- IF MUST MOVE LEFT...
								n.npcpath2.x = n.npcpath2.x - 3
								updatetags()
								updatenpcs()
								else print("[event] EVENT HALF-FINISHED!"); event.timer = 0; event.doupdate = true; event.eventcode = "copupdate-b"; return
							end -- end of if not at target
						end -- end of if must move left
						if event.leftorright == "right" then -- IF MUST MOVE RIGHT...
							getpath2(event.ped)
							if n.npcpath2.x < event.arg1 then
								n.npcpath2.x = n.npcpath2.x + 3
								updatetags()
								updatenpcs()
							else print("[event] EVENT HALF-FINISHED!"); event.timer = 0; event.doupdate = false
							end -- end of if not at target
						end -- end of if must move right
						event.timer = 0
					end -- end of if timer reached
					-- TODO: elseif eventcode is something else...
			end -- end of if quickgascop-a
			if event.eventcode == "copupdate-b" then
				if event.timer < event.timer_max then
						event.timer = event.timer + 1
					end
					if event.timer >= event.timer_max then
						if event.upordown == "down" then
							getpath2(event.ped)
							if n.npcpath2.y < event.arg2 then -- IF MUST MOVE DOWN...
								n.npcpath2.y = n.npcpath2.y + 3
								updatetags()
								else print("[event] EVENT FINISHED!"); event.timer = 0; event.doupdate = false; event.eventcode = "nil"
							end -- end of if not at target
						end -- end of if must move down
						if event.upordown == "up" then -- IF MUST MOVE UP...
							getpath2(event.ped)
							if n.npcpath2.y > event.arg2 then
								n.npcpath2.y = n.npcpath2.y - 3
								updatetags()
							else print("[event] EVENT FINISHED!"); event.timer = 0; event.doupdate = false; event.eventcode = "nil"
							end -- end of if not at target
						end -- end of if must move up
						event.timer = 0
					end -- end of if timer reached
					-- TODO: elseif eventcode is something else...
			end -- end of if quickgascop-a
			if event.doupdate == false then end
		end -- end of event handler

--  start menu
if n.smenu == false then
	function love.mousepressed(x, y, button)
		-- DIALOG
		if dialog.active == true then
			if dialog.colors[1] == 1 then
				append(msg.colors.white, player.name..": "..dialog.options[1])					
				dialog.active = false
			end
			if dialog.colors[2] == 1 then
				append(msg.colors.white, player.name..": "..dialog.options[2])
				dialog.active = false
			end
			if dialog.colors[3] == 1 then
				append(msg.colors.white, player.name..": Nevermind.")
				dialog.active = false
			end
		end
		-- GUNPLAY
		if button == 1 then
			if data.intbox == true then
				local mpos = {love.mouse.getX(), love.mouse.getY()}
				local rpos = {n.npcpath.x, n.npcpath.y}
				if ((mpos[1] >= rpos[1] + 50 and mpos[1] < rpos[1] + 150) and (mpos[2] >= rpos[2] and mpos[2] < rpos[2] + 150)) then
					-- do that thing!
				end
				
				-- find mouse pos, make option handler
				-- if out of bounds, data.intbox = false
				return
			end
		if player.weapons.selected ~= "fists" then
			local aim_x = love.mouse.getX(); local aim_y = love.mouse.getY()
			print("GUN FIRED! ["..aim_x..", "..aim_y.."]")
			weaponfired()
			local snitch = love.math.random(1,3)
			if player.wanted == false and snitch == 1 then wanted(true) end
			local aim_radius = 30
			local hit = true
			if aim_x > (n.npcpath.x + aim_radius) or aim_x < (n.npcpath.x - aim_radius) then hit = false end
			if aim_y > (n.npcpath.y + aim_radius) or aim_y < (n.npcpath.y - aim_radius) then hit = false end
			if hit == false then targethit(nil) end
			if hit == true then
				print("HIT!")
				if player.weapons.selected == "glock" and player.weapons.clip1 > 0 then
					targethit(love.math.random(15, 30))
				end
				if player.weapons.selected == "shorty" and player.weapons.clip2 > 0 then
					targethit(love.math.random(18, 35))
				end
				if player.weapons.selected == "ak" and player.weapons.clip3 > 0 then
					targethit(love.math.random(20, 65))
				end
			end
			-- get ped x, if within 50 either side...
			-- get ped y, if within 50 either side...
		end
		end
		if button == 2 then
			if ped.ped0.hasfocus == true then cscript.runcmd("/target 0"); data.intbox = true end
			if ped.ped1.hasfocus == true then cscript.runcmd("/target 1"); data.intbox = true end
			if ped.ped2.hasfocus == true then cscript.runcmd("/target 2"); data.intbox = true end
			if ped.ped3.hasfocus == true then cscript.runcmd("/target 3"); data.intbox = true end
			if ped.ped4.hasfocus == true then cscript.runcmd("/target 4"); data.intbox = true end
			if ped.ped5.hasfocus == true then cscript.runcmd("/target 5"); data.intbox = true end
			if ped.ped6.hasfocus == true then cscript.runcmd("/target 6"); data.intbox = true end
			if ped.ped7.hasfocus == true then cscript.runcmd("/target 7"); data.intbox = true end
			if ped.ped8.hasfocus == true then cscript.runcmd("/target 8"); data.intbox = true end
			if ped.ped9.hasfocus == true then cscript.runcmd("/target 9"); data.intbox = true end
		end
	end
		n.mousex = love.mouse.getX()
		n.mousey = love.mouse.getY()
		-- ped targeting
		checktarget()
		-- update weapon txtr
		if player.weapons.selected ~= "fists" then
			if player.weapons.selected == "glock" then
				if lk.isDown(sets.move_rt) then player.weapons.weapontxtr = txtrs.weapons.glockr; data.weaponx = 290 end
				if lk.isDown(sets.move_lt) then player.weapons.weapontxtr = txtrs.weapons.glockl; data.weaponx = 240 end -- LEFT CORRECTION
				if lk.isDown(sets.move_up) and not lk.isDown(sets.move_lt) then player.weapons.weapontxtr = txtrs.weapons.glockr; data.weaponx = 290 end
				if lk.isDown(sets.move_dn) and not lk.isDown(sets.move_lt) then player.weapons.weapontxtr = txtrs.weapons.glockf ; data.weaponx = 282 end
				--data.weapony = 255
			end
			if player.weapons.selected == "shorty" then
				if lk.isDown(sets.move_rt) then player.weapons.weapontxtr = txtrs.weapons.shortyr; data.weaponx = 268 end
				if lk.isDown(sets.move_lt) then player.weapons.weapontxtr = txtrs.weapons.shortyl; data.weaponx = 264 end -- LEFT CORRECTION
				if lk.isDown(sets.move_up) and not lk.isDown(sets.move_lt) then player.weapons.weapontxtr = txtrs.weapons.shortyb; data.weaponx = 268 end
				if lk.isDown(sets.move_dn) and not lk.isDown(sets.move_lt) then player.weapons.weapontxtr = txtrs.weapons.shortyr; data.weaponx = 268 end
				--data.weapony = 261
			end
				if player.weapons.selected == "ak" then
				if lk.isDown(sets.move_rt) then player.weapons.weapontxtr = txtrs.weapons.akr; data.weaponx = 270 end
				if lk.isDown(sets.move_lt) then player.weapons.weapontxtr = txtrs.weapons.akl; data.weaponx = 260 end
				if lk.isDown(sets.move_up) then player.weapons.weapontxtr = txtrs.weapons.akb; data.weaponx = 267 end
				if lk.isDown(sets.move_dn) then player.weapons.weapontxtr = txtrs.weapons.akr; data.weaponx = 268 end
			end
		end
		-- day/night cycle
		if graphics.timeofday <= graphics.cyclelength then -- 9000 = apx 2.4 minutes
			graphics.timeofday = graphics.timeofday + 1
			if graphics.dayornight == "day" then
				if graphics.lightr < 255 then
					graphics.lightr = graphics.lightr + 1
					graphics.lightg = graphics.lightg + 1
					graphics.lightb = graphics.lightb + 1
				end
			end
		if graphics.dayornight == "night" then
				if graphics.lightr > 125  then
					graphics.lightr = graphics.lightr - 1
					graphics.lightg = graphics.lightg - 1
					graphics.lightb = graphics.lightb - 1
				end
			end
		end
		if graphics.timeofday >= graphics.cyclelength then
			if graphics.dayornight == "day" then
				txtrs.sky = txtrs.sky2
				append(color.rp, "The sun falls into the western sky.")
				graphics.dayornight = "night"; graphics.timeofday = 0
				audio.night:setLooping(true)
				audio.night:play()
				paycheck()
				return
			end
			if graphics.dayornight == "night" then
				txtrs.sky = txtrs.sky1
				append(color.rp, "The sun rises from the eastern sky.")
				graphics.dayornight = "day"; graphics.timeofday = 0
				audio.night:setLooping(false)
				audio.night:stop()
				lotto()
				data.day = data.day + 1
				return
			end
		end
		-- walk sprite (down)
			if anim.dowalkdown == true then
				anim.sprites.pskin.currentTime = anim.sprites.pskin.currentTime + dt
				if anim.sprites.pskin.currentTime >= anim.sprites.pskin.duration then
					anim.sprites.pskin.currentTime = anim.sprites.pskin.currentTime - anim.sprites.pskin.duration
		end
			if anim.dowalkdown == false then
				anim.sprites.pskin.currentTime = 999
			end
		end -- end of walk down sprite
		-- walk sprite (up)
			if anim.dowalkup == true then
				anim.sprites.pskin2.currentTime = anim.sprites.pskin2.currentTime + dt
				if anim.sprites.pskin2.currentTime >= anim.sprites.pskin2.duration then
					anim.sprites.pskin2.currentTime = anim.sprites.pskin2.currentTime - anim.sprites.pskin2.duration
		end
			if anim.dowalkup == false then
				anim.sprites.pskin2.currentTime = 999
			end
		end -- end of walk up sprite
		-- idle sprite
		if anim.doidle == true and player.ismoving == false then
			anim.sprites.pskin3.currentTime = anim.sprites.pskin3.currentTime + dt
			if anim.sprites.pskin3.currentTime >= anim.sprites.pskin3.duration then
				anim.sprites.pskin3.currentTime = anim.sprites.pskin3.currentTime - anim.sprites.pskin3.duration
		end
			if anim.doidle == false then
				anim.sprites.pskin3.currentTime = 999
			end
		end -- end of idle sprite
		-- npc idle sprite
		anim.sprites.ped0.currentTime = anim.sprites.ped0.currentTime + 1
		anim.sprites.ped1.currentTime = anim.sprites.ped1.currentTime + 1
		anim.sprites.ped2.currentTime = anim.sprites.ped2.currentTime + 1
		anim.sprites.ped3.currentTime = anim.sprites.ped3.currentTime + 1
		anim.sprites.ped4.currentTime = anim.sprites.ped4.currentTime + 1
		anim.sprites.ped5.currentTime = anim.sprites.ped5.currentTime + 1
		anim.sprites.ped6.currentTime = anim.sprites.ped6.currentTime + 1
		anim.sprites.ped7.currentTime = anim.sprites.ped7.currentTime + 1
		anim.sprites.ped8.currentTime = anim.sprites.ped8.currentTime + 1
		anim.sprites.ped9.currentTime = anim.sprites.ped9.currentTime + 1
		anim.sprites.pedEMT.currentTime = anim.sprites.pedEMT.currentTime + 1
			if anim.sprites.ped0.currentTime >= anim.sprites.ped0.duration then
				anim.sprites.ped0.currentTime = anim.sprites.ped0.currentTime - anim.sprites.ped0.duration
		end
			if anim.sprites.ped1.currentTime >= anim.sprites.ped1.duration then
				anim.sprites.ped1.currentTime = anim.sprites.ped1.currentTime - anim.sprites.ped1.duration
		end
			if anim.sprites.ped2.currentTime >= anim.sprites.ped2.duration then
				anim.sprites.ped2.currentTime = anim.sprites.ped2.currentTime - anim.sprites.ped2.duration
		end
			if anim.sprites.ped3.currentTime >= anim.sprites.ped3.duration then
				anim.sprites.ped3.currentTime = anim.sprites.ped3.currentTime - anim.sprites.ped3.duration
		end
			if anim.sprites.ped4.currentTime >= anim.sprites.ped4.duration then
				anim.sprites.ped4.currentTime = anim.sprites.ped4.currentTime - anim.sprites.ped4.duration
		end
			if anim.sprites.ped5.currentTime >= anim.sprites.ped5.duration then
				anim.sprites.ped5.currentTime = anim.sprites.ped5.currentTime - anim.sprites.ped5.duration
		end
			if anim.sprites.ped6.currentTime >= anim.sprites.ped6.duration then
				anim.sprites.ped6.currentTime = anim.sprites.ped6.currentTime - anim.sprites.ped6.duration
		end
			if anim.sprites.ped7.currentTime >= anim.sprites.ped7.duration then
				anim.sprites.ped7.currentTime = anim.sprites.ped7.currentTime - anim.sprites.ped7.duration
		end
			if anim.sprites.ped8.currentTime >= anim.sprites.ped8.duration then
				anim.sprites.ped8.currentTime = anim.sprites.ped8.currentTime - anim.sprites.ped8.duration
		end
			if anim.sprites.ped9.currentTime >= anim.sprites.ped9.duration then
				anim.sprites.ped9.currentTime = anim.sprites.ped9.currentTime - anim.sprites.ped9.duration
		end
			if anim.sprites.pedEMT.currentTime >= anim.sprites.pedEMT.duration then
				anim.sprites.pedEMT.currentTime = anim.sprites.pedEMT.currentTime - anim.sprites.pedEMT.duration
		end
		-- car driving
		if veh.playercar.isparked == false and veh.playercar.speed >= 1 then
			veh.playercar.angle = (math.atan2(n.mousey-(love.graphics:getHeight()/2), n.mousex-(love.graphics:getWidth()/2)))
			veh.playercar.roundstring = tostring(veh.playercar.angle)
			veh.playercar.rounded = tonumber(string.format("%.2f", veh.playercar.roundstring))
			world.x = math.floor(world.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
			world.y = math.floor(world.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
			veh.playercar.hlightx = math.floor(world.x - math.sin(veh.playercar.rounded) * veh.playercar.speed)
			veh.playercar.hlighty = math.floor(world.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
			updatenpcs_car()
			updatetags()
			if veh.playercar.rounded < 1 and veh.playercar.rounded > -3.14 then veh.playercar.rot = veh.playercar.rounded + 1.60 end
			if veh.playercar.rounded < 3.14 and veh.playercar.rounded > 1 then veh.playercar.rot = veh.playercar.rounded + 1.50 end
		end
	-- travel detection
	if world.x >= 200 then data.movingw = true else data.movingw = false end
	if world.x <= -1300 then data.movinge = true else data.movinge = false end
	if world.y >= 200 then data.movingn = true else data.movingn = false end
	if world.y <= -1300 then data.movings = true else data.movings = false end		
	if data.movingn ~= true and data.movinge ~= true and data.movings ~= true and data.movingw ~= true and data.movingnw ~= true and data.movingsw ~= true and data.movingse ~= true and data.movingne ~= true then
		data.movingto = "nil"
	end
	-- marker detection
	if n.marker.draw == true then
		if player.x - n.marker.pos_x < 50 and player.y - n.marker.pos_y < 50 then
			marker_entered()
		end
	end	
-- | movement
	if msg.box == false and player.canmove == true then	
		if lk.isDown(sets.move_up) then
			player.face = 1
			txtrs.weapons.glock = txtrs.weapons.glockb
			txtrs.weapons.shorty = txtrs.weapons.shortyb
			txtrs.weapons.ak = txtrs.weapons.akb
			world.y = world.y + player.speed
			n.marker.pos_y = n.marker.pos_y + player.speed
			anim.walk = anim.walk + 1
			animwalk("up")
			anim.dowalkup = true; anim.dowalkdown = false; anim.doidle = false
--			player.clothes.torso = player.clothes.torso_b
			updatenpcs(1)
		end
		if lk.isDown(sets.move_dn) then
			player.face = 3
			if lk.isDown(sets.move_rt) then player.face2 = 2 end
			if lk.isDown(sets.move_lt) then player.face2 = 4 end
			txtrs.weapons.glock = txtrs.weapons.glockr
			txtrs.weapons.shorty = txtrs.weapons.shortyr
			txtrs.weapons.ak = txtrs.weapons.akr
			world.y = world.y - player.speed
			n.marker.pos_y = n.marker.pos_y - player.speed
			anim.walk = anim.walk + 1
			animwalk("down")
			anim.dowalkup = false; anim.dowalkdown = true; anim.doidle = false
--			player.clothes.torso = player.clothes.torso_f
			updatenpcs(3)
		end
		if lk.isDown(sets.move_lt) then
			player.face = 4
			if lk.isDown(sets.move_up) then player.face2 = 1 end
			if lk.isDown(sets.move_dn) then player.face2 = 3 end
			txtrs.weapons.glock = txtrs.weapons.glockl
			txtrs.weapons.shorty = txtrs.weapons.shortyl
			txtrs.weapons.ak = txtrs.weapons.akl
			world.x = world.x + player.speed
			n.marker.pos_x = n.marker.pos_x + player.speed
			anim.walk = anim.walk + 1
			animwalk("left")
			if lk.isDown(sets.move_up) then anim.dowalkup = true; anim.dowalkdown = false; anim.doidle = false end
			if lk.isDown(sets.move_dn) then anim.dowalkup = false; anim.dowalkdown = true; anim.doidle = false end
			if not lk.isDown(sets.move_up) and not lk.isDown(sets.move_dn) then anim.dowalkup = false; anim.dowalkdown = true; anim.doidle = false end
--			player.clothes.torso = player.clothes.torso_f
			updatenpcs(4)
		end
		if lk.isDown(sets.move_rt) then
			if lk.isDown(sets.move_up) then player.face2 = 1 end
			if lk.isDown(sets.move_dn) then player.face2 = 3 end
			player.face = 2
			world.x = world.x - player.speed
			n.marker.pos_x = n.marker.pos_x - player.speed
			txtrs.weapons.glock = txtrs.weapons.glockr
			txtrs.weapons.shorty = txtrs.weapons.shortyr
			txtrs.weapons.ak = txtrs.weapons.akr
			anim.walk = anim.walk + 1
			animwalk("right")
			if lk.isDown(sets.move_up) then anim.dowalkup = true; anim.dowalkdown = false; anim.doidle = false end
			if lk.isDown(sets.move_dn) then anim.dowalkup = false; anim.dowalkdown = true; anim.doidle = false end
			if not lk.isDown(sets.move_up) and not lk.isDown(sets.move_dn) then anim.dowalkup = false; anim.dowalkdown = true; anim.doidle = false end
--			player.clothes.torso = player.clothes.torso_f
			updatenpcs(2)
		end
		if lk.isDown(sets.move_up) or lk.isDown(sets.move_dn) or lk.isDown(sets.move_lt) or lk.isDown(sets.move_rt) and player.issprinting == false and veh.playercar.isparked == true then
			if audio.walk:isPlaying() ~= true and n.devmode == false then audio.walk:play() end
		end
		
		if veh.playercar.isparked == true then -- if car parked			
			if player.isaiming == true then svc.walkanimmax = 30 end
			if player.issprinting == true then svc.walkanimmax = 8 end
			if player.issprinting == false and player.isaiming == false then svc.walkanimmax = 15 end
			end
		if player.y == 250 then player.clothes.goreY = 250; player.clothes.torsoY = 250; player.clothes.handY = 250 end
		if not(lk.isDown(sets.move_up) or lk.isDown(sets.move_dn) or lk.isDown(sets.move_lt) or lk.isDown(sets.move_rt)) and svc.walkanim >= 0 then data.weapony = 250 player.y = 250; svc.walkanim = svc.walkanimmax end -- audio.walk:stop(); audio.run:stop()
	end -- end of if canmove
		-- command line clear
		if msg.box == true and lk.isDown("lctrl") and lk.isDown("a") then msg.boxmsg = "" end
		
	function love.keypressed(key)
		if n.smenu == false then
		if key == "f1" and n.devmode == false then cscript.runcmd("/devmode on"); return end
		if key == "i" and msg.box == false and n.inv == false then cscript.runcmd("/inv on"); return end
		if key == "i" and msg.box == false and n.inv == true then cscript.runcmd("/inv off"); return end
		if key == "f1" and n.devmode == true then cscript.runcmd("/devmode off"); return end
		if key == "f2" then cscript.runcmd("/mpos"); end
		if key == sets.sprint and player.cansprint == true and n.devmode == false and veh.playercar.isparked == true then player.speed = player.fastspeed; player.issprinting = true end -- audio.run:play(); audio.run:setLooping(true)
		if key == sets.reload and msg.box == false and player.weapons.selected ~= "fists" then
			cscript.runcmd("/reload")
		end
		if key == "escape" then msg.boxmsg = ""; msg.box = false end
			if key == sets.accept and msg.box == false then cscript.runcmd("/travel") end
			-- car stuff
			if key == sets.upshift and msg.box == false then cscript.runcmd("/upshift") end
			if key == sets.dnshift and msg.box == false then cscript.runcmd("/downshift") end
			if key == sets.car and msg.box == false then cscript.runcmd("/car") end
			if key == sets.enter and msg.box == false then cscript.runcmd("/enter") end
			if key == sets.exit and msg.box == false then cscript.runcmd("/exit") end
			if key == "1" and msg.box == false then cscript.runcmd("/equip 1") end
			if key == "2" and msg.box == false then cscript.runcmd("/equip 2") end
			if key == "3" and msg.box == false then cscript.runcmd("/equip 3") end
			if key == "0" and msg.box == false then cscript.runcmd("/equip 0") end
		-- | command line
		if msg.box == true then
			msg.boxchars = string.len(msg.boxmsg)
			if msg.boxchars >= 40 and key ~= "backspace" then return end
			if key ~= "space" and key ~= "backspace" and key ~= "lshift" and key ~= "rshift" and key ~= "return" and key ~= "up" and key ~= "down" and key ~= "lctrl" then msg.boxmsg = msg.boxmsg..key end
			if key == "space" then msg.boxmsg = msg.boxmsg.." " end
			if key == "backspace" then msg.boxmsg = msg.boxmsg:sub(1, -2) end
			if key == "return" then cscript.runcmd(msg.boxmsg) end
			if key == "up" then msg.boxmsg = svc.lastcmd end
			if key == "down" then msg.boxmsg = "" end
		end

		if key == sets.msgbox and msg.box == false and n.smenu == false then msg.boxmsg = "" msg.box = true; return end
		end
	end
	function love.keyreleased(key)
		if key == sets.sprint and n.devmode == false then
			player.speed = player.regularspeed
			player.issprinting = false
			audio.walk:stop()
		end
		if player.canmove == true then
			if key == sets.move_up or key == sets.move_dn or key == sets.move_lt or key == sets.move_rt then
				audio.walk:stop()
				anim.dowalkup = false; anim.dowalkdown = false
			end
			if not lk.isDown("w") and not lk.isDown("s") and not lk.isDown("a") and not lk.isDown("d") then player.ismoving = false end
			if key == sets.move_up then if n.devmode == false then end; player.face = 1; anim.dowalkup = false; anim.doidle = true end
			if key == sets.move_dn then if n.devmode == false then end; player.face = 3; anim.dowalkdown = false; anim.doidle = true end
			if key == sets.move_lt then if n.devmode == false then end; player.face = 4; anim.dowalkdown = false; anim.doidle = true end
			if key == sets.move_rt then if n.devmode == false then end; player.face = 2; anim.dowalkdown = false; anim.doidle = true end
		end -- end of if canmove
	if key == sets.fire and msg.box == false and n.devmode == false then
			player.isaiming = false
			player.cansprint = true
			player.speed = player.regularspeed
			if player.weapons.selected == "glock" then player.weapons.weapontxtr = txtrs.weapons.glockr end
			if player.weapons.selected == "shorty" then player.weapons.weapontxtr = txtrs.weapons.shortyr end
			if player.weapons.selected == "ak" then player.weapons.weapontxtr = txtrs.weapons.akr end
		end -- TODO: decrease accuracy back for hipshooting
	end
	if data.responce_fd == true and data.fdtimer >= 999 then data.fdtimer = 0 end
	if data.responce_fd == true and data.fdtimer < 175 then
		data.fdtimer = data.fdtimer + 1
		ped.emt.y = ped.emt.y + 2
	end
	if data.responce_fd == true and data.fdtimer >= 175 then
		data.fdarrived = true
		data.fdtimer = 0
		data.responce_fd = false
		data.fdresponce = false
		data.fdfinished = true
	end
	if data.fdarrived == true then
		local fee = love.math.random(150, 350)
		cscript.runcmd("/equip 0")
		append(color.rp, "A paramedic tends to "..player.name.."'s injuries and heals them.")
		append(color.rp, "You are transported to the hospital, and edventually discharged.")
		player.inint = false
		append(color.red, "You've been charged $"..fee.." for medical treatment.")
		n.npcpath.holstered = true
		player.cash = player.cash - fee
		world.x = -200; world.y = -1350
		txtrs.city.txtr = txtrs.city.downtown
		city.downtown = true
		city.southeast = false
		city.southmid = false
		city.midwest = false
		city.mideast = false
		player.isdown = false
		player.canmove = false
		player.hpcolor = color.white
		player.hp = player.hp + 20
		player.ap = 0
		data.fdarrived = false
	end
	if data.fdfinished == true and data.fdtimer < 500 then
		ped.emt.x = ped.emt.x + 1
	end
	if ped.emt.x <= -600 or ped.emt.x >= 600 then player.canmove = true; data.fdtimer = 999; data.emsrespond = false; player.clothes.gore = txtrs.clothes.none; data.responce_fd = false; data.fdresponce = false; ped.emt.x = 250; ped.emt.y = -100;  end
	if player.ap < 0 and player.clothes.torso ~= txtrs.clothes.none then player.clothes.torso = txtrs.clothes.none; player.clothes.torso_f = txtrs.clothes.none; player.clothes.torso_b = txtrs.clothes.none; player.speed = 2; player.canmove = true; player.regularpseed = 2 end
end -- end of if smenu
end -- end of love.update
end -- end of update

function draw()
function love.draw() -- (layering) TOP: passive, BOTTOM: aggressive
if n.smenu == false then
-- general
lg.setFont(graphics.font)
lg.setColor(graphics.lightr, graphics.lightg, graphics.lightb, graphics.lightalpha)
lg.draw(txtrs.sky, 0, 0)
-- world/interior
lg.draw(txtrs.city.txtr, world.x, world.y)
lg.setColor(1, 1, 1, 1)
lg.draw(txtrs.vig, 0, 0)
lg.setColor(graphics.lightr, graphics.lightg, graphics.lightb, graphics.lightalpha)
-- marker
if n.marker.draw == true then lg.draw(n.marker.style, n.marker.pos_x, n.marker.pos_y) end
-- player anims
anim.spriteNum = math.floor(anim.sprites.pskin.currentTime / anim.sprites.pskin.duration * #anim.sprites.pskin.quads) + 1.0
anim.spriteNum2 = math.floor(anim.sprites.pskin2.currentTime / anim.sprites.pskin2.duration * #anim.sprites.pskin2.quads) + 1.0
anim.spriteNum3 = math.floor(anim.sprites.pskin3.currentTime / anim.sprites.pskin3.duration * #anim.sprites.pskin3.quads) + 1.0
-- ped anims
anim.p0spriteNum = math.floor(anim.sprites.ped0.currentTime / anim.sprites.ped0.duration * #anim.sprites.ped0.quads) + 1.0
anim.p1spriteNum = math.floor(anim.sprites.ped1.currentTime / anim.sprites.ped1.duration * #anim.sprites.ped1.quads) + 1.0
anim.p2spriteNum = math.floor(anim.sprites.ped2.currentTime / anim.sprites.ped2.duration * #anim.sprites.ped2.quads) + 1.0
anim.p3spriteNum = math.floor(anim.sprites.ped3.currentTime / anim.sprites.ped3.duration * #anim.sprites.ped3.quads) + 1.0
anim.p4spriteNum = math.floor(anim.sprites.ped4.currentTime / anim.sprites.ped4.duration * #anim.sprites.ped4.quads) + 1.0
anim.p5spriteNum = math.floor(anim.sprites.ped5.currentTime / anim.sprites.ped5.duration * #anim.sprites.ped5.quads) + 1.0
anim.p6spriteNum = math.floor(anim.sprites.ped6.currentTime / anim.sprites.ped6.duration * #anim.sprites.ped6.quads) + 1.0
anim.p7spriteNum = math.floor(anim.sprites.ped7.currentTime / anim.sprites.ped7.duration * #anim.sprites.ped7.quads) + 1.0
anim.p8spriteNum = math.floor(anim.sprites.ped8.currentTime / anim.sprites.ped8.duration * #anim.sprites.ped8.quads) + 1.0
anim.p9spriteNum = math.floor(anim.sprites.ped9.currentTime / anim.sprites.ped9.duration * #anim.sprites.ped9.quads) + 1.0
anim.pEMTspriteNum = math.floor(anim.sprites.pedEMT.currentTime / anim.sprites.pedEMT.duration * #anim.sprites.pedEMT.quads) + 1.0
-- npcs
lg.setColor(peds.ped0.color)
lg.draw(anim.sprites.ped0.spriteSheet, anim.sprites.ped0.quads[anim.p0spriteNum], peds.ped0.x, peds.ped0.y)
lg.setColor(peds.ped1.color)
lg.draw(anim.sprites.ped1.spriteSheet, anim.sprites.ped1.quads[anim.p1spriteNum], peds.ped1.x, peds.ped1.y)
lg.setColor(peds.ped2.color)
lg.draw(anim.sprites.ped2.spriteSheet, anim.sprites.ped2.quads[anim.p2spriteNum], peds.ped2.x, peds.ped2.y)
lg.setColor(peds.ped3.color)
lg.draw(anim.sprites.ped3.spriteSheet, anim.sprites.ped3.quads[anim.p3spriteNum], peds.ped3.x, peds.ped3.y)
lg.setColor(peds.ped4.color)
lg.draw(anim.sprites.ped4.spriteSheet, anim.sprites.ped4.quads[anim.p4spriteNum], peds.ped4.x, peds.ped4.y)
lg.setColor(peds.ped5.color)
lg.draw(anim.sprites.ped5.spriteSheet, anim.sprites.ped5.quads[anim.p5spriteNum], peds.ped5.x, peds.ped5.y)
lg.setColor(peds.ped6.color)
lg.draw(anim.sprites.ped6.spriteSheet, anim.sprites.ped6.quads[anim.p6spriteNum], peds.ped6.x, peds.ped6.y)
lg.setColor(peds.ped7.color)
lg.draw(anim.sprites.ped7.spriteSheet, anim.sprites.ped7.quads[anim.p7spriteNum], peds.ped7.x, peds.ped7.y)
lg.setColor(peds.ped8.color)
lg.draw(anim.sprites.ped8.spriteSheet, anim.sprites.ped8.quads[anim.p8spriteNum], peds.ped8.x, peds.ped8.y)
lg.setColor(peds.ped9.color)
lg.draw(anim.sprites.ped9.spriteSheet, anim.sprites.ped9.quads[anim.p9spriteNum], peds.ped9.x, peds.ped9.y)
lg.setColor(1, 1, 1, 1)
-- npc nametags/clothing slot
lg.print(""..ped.ped1.name.." (1)", ped.ped1.drawnameX, ped.ped1.drawnameY)
lg.draw(peds.ped1.clothes, peds.ped1.drawclothesX, peds.ped1.drawclothesY)
if peds.ped1.holstered == false then lg.draw(peds.ped1.weapon, peds.ped1.drawclothesX, peds.ped1.drawclothesY) end
lg.print(""..ped.ped2.name.." (2)", ped.ped2.drawnameX, ped.ped2.drawnameY)
lg.draw(peds.ped2.clothes, peds.ped1.drawclothesX, peds.ped2.drawclothesY)
if peds.ped2.holstered == false then lg.draw(peds.ped2.weapon, peds.ped2.drawclothesX, peds.ped2.drawclothesY) end
lg.print(""..ped.ped3.name.." (3)", ped.ped3.drawnameX, ped.ped3.drawnameY)
lg.draw(peds.ped3.clothes, peds.ped3.drawclothesX, peds.ped3.drawclothesY)
if peds.ped3.holstered == false then lg.draw(peds.ped3.weapon, peds.ped3.drawclothesX, peds.ped3.drawclothesY) end
lg.print(""..ped.ped4.name.." (4)", ped.ped4.drawnameX, ped.ped4.drawnameY)
if peds.ped4.holstered == false then lg.draw(peds.ped4.weapon, peds.ped4.drawclothesX, peds.ped4.drawclothesY) end
lg.draw(peds.ped4.clothes, peds.ped4.drawclothesX, peds.ped4.drawclothesY)
lg.print(""..ped.ped5.name.." (5)", ped.ped5.drawnameX, ped.ped5.drawnameY)
lg.draw(peds.ped5.clothes, peds.ped5.drawclothesX, peds.ped5.drawclothesY)
if peds.ped5.holstered == false then lg.draw(peds.ped5.weapon, peds.ped5.drawclothesX, peds.ped5.drawclothesY) end
lg.print(""..ped.ped6.name.." (6)", ped.ped6.drawnameX, ped.ped6.drawnameY)
lg.draw(peds.ped6.clothes, peds.ped6.drawclothesX, peds.ped6.drawclothesY)
if peds.ped6.holstered == false then lg.draw(peds.ped6.weapon, peds.ped6.drawclothesX, peds.ped6.drawclothesY) end
lg.print(""..ped.ped7.name.." (7)", ped.ped7.drawnameX, ped.ped7.drawnameY)
lg.draw(peds.ped7.clothes, peds.ped7.drawclothesX, peds.ped7.drawclothesY)
if peds.ped7.holstered == false then lg.draw(peds.ped7.weapon, peds.ped7.drawclothesX, peds.ped7.drawclothesY) end
lg.print(""..ped.ped8.name.." (8)", ped.ped8.drawnameX, ped.ped8.drawnameY)
lg.draw(peds.ped8.clothes, peds.ped8.drawclothesX, peds.ped8.drawclothesY)
if peds.ped8.holstered == false then lg.draw(peds.ped8.weapon, peds.ped8.drawclothesX, peds.ped8.drawclothesY) end
lg.print(""..ped.ped9.name.." (9)", ped.ped9.drawnameX, ped.ped9.drawnameY)
lg.draw(peds.ped9.clothes, peds.ped9.drawclothesX, peds.ped9.drawclothesY)
if peds.ped9.holstered == false then lg.draw(peds.ped9.weapon, peds.ped9.drawclothesX, peds.ped9.drawclothesY) end
lg.print(""..ped.ped0.name.." (0)", ped.ped0.drawnameX, ped.ped0.drawnameY)
lg.draw(peds.ped0.clothes, peds.ped0.drawclothesX, peds.ped0.drawclothesY)
if peds.ped0.holstered == false then lg.draw(peds.ped0.weapon, peds.ped0.drawclothesX, peds.ped0.drawclothesY) end
-- ped interaction box
if data.intbox == true then
lg.setColor(0.1, 0.1, 0.1, 0.75)
lg.rectangle("fill", n.npcpath.x + 50, n.npcpath.y, 100, 100)
lg.setColor(data.intoption1)
lg.print("Chat", n.npcpath.x + 55, n.npcpath.y + 5)
lg.setColor(data.intoption2)
lg.print("Examine", n.npcpath.x + 55, n.npcpath.y + 30)
lg.setColor(data.intoption3)
lg.print("Special", n.npcpath.x + 55, n.npcpath.y + 55) -- arrest, heal, rob, etc.
lg.setColor(data.intoption4)
lg.print("Back", n.npcpath.x + 55, n.npcpath.y + 80)
lg.setColor(1, 1, 1, 1)	
end
-- inventory hud
if n.inv == true then
	lg.setColor(0, 0, 0, 0.25)
	lg.rectangle("fill", 16, 166, 240, 256)
	lg.setColor(0, 0, 0, 0.5)
	-- weapons
	lg.rectangle("fill", 88, 186, 40, 40)
	lg.rectangle("fill", 144, 186, 40, 40)
	-- items
	lg.rectangle("fill", 32, 280, 40, 40)
	lg.rectangle("fill", 88, 280, 40, 40)
	lg.rectangle("fill", 144, 280, 40, 40)
	lg.rectangle("fill", 200, 280, 40, 40)
	lg.rectangle("fill", 32, 336, 40, 40)
	lg.rectangle("fill", 88, 336, 40, 40)
	lg.rectangle("fill", 144, 336, 40, 40)
	lg.rectangle("fill", 200, 336, 40, 40)
	lg.setColor(1, 1, 1, 1)
	lg.print("- INVENTORY -", 78, 168)
	-- labels and images
	lg.print("(3)    (4)   (5)    (6)", 42, 260)
	lg.print("(7)    (8)   (9)    (0)", 42, 320)
	lg.print("(1)    (2)", 96, 224)
	if inv.weed.qnty > 0 then lg.draw(txtrs.items.weed, 36, 284); lg.print("x"..inv.weed.qnty, 36, 284) end
	if inv.coke.qnty > 0 then lg.draw(txtrs.items.coke, 92, 284); lg.print("x"..inv.coke.qnty, 92, 284) end
	if inv.fourty.qnty > 0 then lg.draw(txtrs.items.beer, 148, 284); lg.print("x"..inv.fourty.qnty, 148, 284) end
end
-- dmg indicator
if n.dmgind_on == true then
	lg.setColor(color.red)
	lg.print(""..n.dmgind, n.npcpath.x, n.npcpath.y)
	lg.setColor(color.white)
end
	-- ems response
	if data.emsrespond == true then
		lg.print("FD Timer: T+"..data.fdtimer.."\nEMT: "..ped.emt.x..", "..ped.emt.y, 25, 500)
		lg.draw(anim.sprites.pedEMT.spriteSheet, anim.sprites.pedEMT.quads[anim.pEMTspriteNum], peds.emt.x, peds.emt.y)
	end
--if veh.playercar.isparked == true then (HIDE PLAYER WHILE DRIVING)
if anim.dowalkup == false and anim.dowalkdown == true then
	love.graphics.draw(anim.sprites.pskin.spriteSheet, anim.sprites.pskin.quads[anim.spriteNum], player.x, player.y)
elseif anim.dowalkup == true and anim.dowalkdown == false then love.graphics.draw(anim.sprites.pskin2.spriteSheet, anim.sprites.pskin2.quads[anim.spriteNum2], player.x, player.y)
end
if anim.doidle == true then
	love.graphics.draw(anim.sprites.pskin3.spriteSheet, anim.sprites.pskin3.quads[anim.spriteNum3], player.x, player.y)
end

lg.draw(player.clothes.gore, player.clothes.goreX, player.clothes.goreY)
lg.draw(player.clothes.torso, player.clothes.torsoX, player.clothes.torsoY)
lg.draw(player.weapons.weapontxtr, data.weaponx, data.weapony)
lg.draw(player.clothes.hand, player.clothes.handX, player.clothes.handY)
if graphics.npcveh1_active == true then
	lg.draw(graphics.npcveh1_txtr, graphics.npcveh1_x, graphics.npcveh1_y, graphics.npcveh1_rot)
end
-- cars
lg.draw(veh.playercar.txtr, veh.playercar.drawx, veh.playercar.drawy,veh.playercar.rot, 1, 1, veh.playercar.txtr:getWidth()/2, veh.playercar.txtr:getHeight()/2)
	if n.devmode == true or n.devtags == true then
		lg.print("NPCS".."\nped1: "..ped.ped1.x..", "..ped.ped1.y.."\nped2: "..ped.ped2.x..", "..ped.ped2.y.."\nped3: "..ped.ped3.x..", "..ped.ped3.y.."\nped4: "..ped.ped4.x..", "..ped.ped4.y.."\nped5: "..ped.ped5.x..", "..ped.ped5.y.."\nped6: "..ped.ped6.x..", "..ped.ped6.y.."\nped7: "..ped.ped7.x..", "..ped.ped7.y.."\nped8: "..ped.ped8.x..", "..ped.ped8.y.."\nped9: "..ped.ped9.x..", "..ped.ped9.y.."\nped0: "..ped.ped0.x..", "..ped.ped0.y, 450, 175)
		lg.print("world.x: "..world.x..", world.y: "..world.y.." - player.x: "..player.x..", player.y: "..player.y.."\nplayer.speed: "..player.speed.." player.face: "..player.face.." + "..player.face2.." - mX: "..n.mousex..", mY: "..n.mousey, 10, 400)
		lg.print("marker.pos_x: "..n.marker.pos_x.."\npos_y: "..n.marker.pos_y, 400, 350)
		lg.print("anim.walk: "..anim.walk.." / "..anim.walkmax.." (phase "..anim.walkphase.."/2)", 10, 435)
		lg.print("\nplayerY: "..player.y.." , torsoY: "..player.clothes.torsoY..", goreY: "..player.clothes.goreY..", handY: "..player.clothes.handY..", data.wepY: "..data.weapony, 10, 435)
		lg.print("\n\nplayercar x:"..veh.playercar.drawx..", playercar y: "..veh.playercar.drawy.." angle: "..veh.playercar.rounded.." speed: "..veh.playercar.speed.." isparked: "..tostring(veh.playercar.isparked), 10, 435)
		lg.print("\n\n\ngraphics.timeofday: "..graphics.timeofday.."/"..graphics.cyclelength.." (dayornight: "..graphics.dayornight..")", 10, 435)
	end
-- HUD
	lg.setColor(1, 1, 1, 1)
	if dialog.active == true then
		local shade1 = msg.colors.white
		local shade2 = msg.colors.white
		local shade3 = msg.colors.white
		if dialog.colors[1] == 1 then shade1 = msg.colors.red; shade2 = msg.colors.white; shade3 = msg.colors.white end
		if dialog.colors[2] == 1 then shade2 = msg.colors.red; shade1 = msg.colors.white; shade3 = msg.colors.white end
		if dialog.colors[3] == 1 then shade3 = msg.colors.red; shade1 = msg.colors.white; shade2 = msg.colors.white end
	
	
		lg.setColor(0.2, 0.2, 0.2, .85) -- dialog background color
		-- mode, x, y, width, height
		lg.rectangle("fill", 100, 300, 400, 175) -- dialog box
		lg.setColor(0.1, 0.1, 0.1, .75) -- dialog option color
		lg.rectangle("fill", 100, 325, 400, 25) -- dialog option
		lg.setColor(shade1) -- selected option color
		lg.print(dialog.options[1], 125, 330)
		lg.setColor(0.1, 0.1, 0.1, .75) -- option 2 color
		lg.rectangle("fill", 100, 375, 400, 25) -- option 2 
		lg.setColor(shade2)
		lg.print(dialog.options[2], 125, 380)
		lg.setColor(0.1, 0.1, 0.1, .75) -- option 3 color
		lg.rectangle("fill", 100, 425, 400, 25) -- option 3
		lg.setColor(shade3)
		lg.print("Nevermind.", 125, 430)
	end
	local radar = false
	if radar == true then
		lg.push()
		lg.scale(0.1, 0.1)
		lg.draw(txtrs.city.txtr, 400/0.1, 400/0.1) -- '/ 0.5' because scale affects everything, including position obviously
		lg.pop() -- so the scale doesn't affect anything else	]]
	end
	lg.setColor(.10, .10, .10, .55)
	lg.rectangle("fill", 0, 0, 600, 150)
	lg.setColor(msg.color0)
	lg.print(msg.line0, 10, 10)
	lg.setColor(msg.color1)
	lg.print(msg.line1, 10, 22)
	lg.setColor(msg.color2)
	lg.print(msg.line2, 10, 38)
	lg.setColor(msg.color3)
	lg.print(msg.line3, 10, 50)
	lg.setColor(msg.color4)
	lg.print(msg.line4, 10, 62)
	lg.setColor(msg.color5)
	lg.print(msg.line5, 10, 74)	
	lg.setColor(msg.color6)
	lg.print(msg.line6, 10, 86)
	lg.setColor(msg.color7)
	lg.print(msg.line7, 10, 98)
	lg.setColor(msg.color8)
	lg.print(msg.line8, 10, 110)
	lg.setColor(msg.color9)
	lg.print(msg.line9, 10, 122)
	lg.setFont(graphics.font)
	if msg.box == true then
		lg.draw(txtrs.chatbox, msg.boxcordx, msg.boxcordy)
		lg.setNewFont(12)
		lg.setColor(1, 1, 1, 1)
		lg.print(msg.boxmsg, 7, 155)
	end
	lg.setFont(graphics.font)
	lg.setColor(msg.colors.white)
	if player.weapons.selected == "glock" then
		lg.print("9mm Pistol ("..player.weapons.clip1.."/"..player.weapons.maxclip1..")", 435, 550)
		lg.print("9mm Rounds: "..player.weapons.ammo1, 465, 575)
	elseif player.weapons.selected == "shorty" then
		lg.print("Super Shorty ("..player.weapons.clip2.."/"..player.weapons.maxclip2..")", 425, 550)
		lg.print("12 Guage Shells: "..player.weapons.ammo2, 425, 575)
	elseif player.weapons.selected == "ak" then
		lg.print("AK-47 ("..player.weapons.clip3.."/"..player.weapons.maxclip3..")", 475, 550)
		lg.print("7.62 Rounds: "..player.weapons.ammo3, 455, 575)
	end
	-- general hud
	lg.setColor(1, 1, 1, 1)
	lg.print(""..city.hoodstring, 10, 485)
	lg.print("TIME: "..graphics.timeh..":00 (Day "..data.day..")", 10, 500)
	lg.print(player.name.." (Level "..player.lvl.." "..player.factionrank..") ["..player.xp.."/"..player.maxxp.." XP]", 10, 575)
	lg.setColor(color.black)
	lg.rectangle("line", 59, 525, 102, 10)
	lg.rectangle("line", 59, 541, 102, 10)
	lg.setColor(color.dred)
	lg.rectangle("fill", 60, 526, 100, 8)
	lg.setColor(color.red)
	lg.rectangle("fill", 60, 526, player.hp, 8)
	lg.setColor(color.gray)
	lg.rectangle("fill", 60, 542, 100, 8)
	lg.setColor(color.lgray)
	lg.rectangle("fill", 60, 542, player.ap, 8)
	lg.setColor(player.hpcolor)
	lg.print("\n"..player.hp.."HP", 10, 505)
	lg.setColor(color.white)
	lg.print("\n\n"..player.ap.."AP", 10, 505)
	if player.cash < 0 then lg.setColor(msg.colors.red) else lg.setColor(msg.colors.green) end
	local displaycash = string.gsub(player.cash, "^(-?%d+)(%d%d%d)", '%1,%2')
	lg.print("\n\n\n$"..displaycash.."", 10, 500)
	lg.setColor(1, 1, 1, 1)
	if n.mpos == true then
		lg.print("X: "..n.mousex..", Y: "..n.mousey, n.mousex, (n.mousey - 20))
	end
	lg.setColor(graphics.lightr, graphics.lightg, graphics.lightb, graphics.lightalpha)
-- (next)
end -- end of if smenu
end -- end of love.draw
end -- end of update

function gethoodid()
local hname = "nil"
		if city.hood == 1 then hname = "Coastal Bay" end
		if city.hood == 2 then hname = "Northmid" end
		if city.hood == 3 then hname = "Uptown" end
		if city.hood == 4 then hname = "El Corazon" end
		if city.hood == 5 then hname = "Downtown" end
		if city.hood == 6 then hname = "Mideast" end
		if city.hood == 7 then hname = "The Dockyards" end
		if city.hood == 8 then hname = "Southmid" end
		if city.hood == 9 then hname = "Parkwood" end
city.hoodstring = hname
end

function updaterank(rank)
	if player.factionid == 1 then -- pd
		if rank == 1 then player.factionrank = fac.pd.rank1; player.factionrankid = 1
			elseif rank == 2 then player.factionrank = fac.pd.rank2; player.factionrankid = 2
			elseif rank == 3 then player.factionrank = fac.pd.rank3; player.factionrankid = 3
			elseif rank == 4 then player.factionrank = fac.pd.rank4; player.factionrankid = 4
			elseif rank == 5 then player.factionrank = fac.pd.rank5; player.factionrankid = 5
		end
	end
	if player.factionid == 2 then -- fd
		if rank == 1 then player.factionrank = fac.fd.rank1; player.factionrankid = 1
			elseif rank == 2 then player.factionrank = fac.fd.rank2; player.factionrankid = 2
			elseif rank == 3 then player.factionrank = fac.fd.rank3; player.factionrankid = 3
			elseif rank == 4 then player.factionrank = fac.fd.rank4; player.factionrankid = 4
			elseif rank == 5 then player.factionrank = fac.fd.rank5; player.factionrankid = 5
		end
	end
	if player.factionid == 3 or player.factionid == 4 or player.factionid == 5 then -- gangs
		if rank == 1 then player.factionrank = fac.gang.rank1; player.factionrankid = 1
			elseif rank == 2 then player.factionrank = fac.gang.rank2; player.factionrankid = 2
			elseif rank == 3 then player.factionrank = fac.gang.rank3; player.factionrankid = 3
			elseif rank == 4 then player.factionrank = fac.gang.rank4; player.factionrankid = 4
			elseif rank == 5 then player.factionrank = fac.gang.rank5; player.factionrankid = 5
		end
	end	
	if player.factionid == 6 then -- trucking (sl)
		if rank == 1 then player.factionrank = fac.sl.rank1; player.factionrankid = 1
			elseif rank == 2 then player.factionrank = fac.sl.rank2; player.factionrankid = 2
			elseif rank == 3 then player.factionrank = fac.sl.rank3; player.factionrankid = 3
			elseif rank == 4 then player.factionrank = fac.sl.rank4; player.factionrankid = 4
			elseif rank == 5 then player.factionrank = fac.sl.rank5; player.factionrankid = 5
		end
	end
end -- end of updaterank()

function movecar(mode)
	if mode == 1 then -- away
		veh.playercar.drawx = -999
		veh.playercar.drawy = -999
	end
	if mode == 2 then -- toward
		veh.playercar.drawx = veh.playercar.parkx
		veh.playercar.drawy = veh.playercar.parky
	end
end

function updatenpcs_car()
		ped.ped0.x = math.floor(ped.ped0.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped0.y = math.floor(ped.ped0.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped0.drawclothesY = math.floor(ped.ped0.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped0.drawclothesX = math.floor(ped.ped0.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped1.x = math.floor(ped.ped1.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped1.y = math.floor(ped.ped1.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped1.drawclothesY = math.floor(ped.ped1.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped1.drawclothesX = math.floor(ped.ped1.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped2.x = math.floor(ped.ped2.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped2.y = math.floor(ped.ped2.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped2.drawclothesY = math.floor(ped.ped2.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped2.drawclothesX = math.floor(ped.ped2.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped3.x = math.floor(ped.ped3.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped3.y = math.floor(ped.ped3.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped3.drawclothesY = math.floor(ped.ped3.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped3.drawclothesX = math.floor(ped.ped3.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped4.x = math.floor(ped.ped4.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped4.y = math.floor(ped.ped4.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped4.drawclothesY = math.floor(ped.ped4.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped4.drawclothesX = math.floor(ped.ped4.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped5.x = math.floor(ped.ped5.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped5.y = math.floor(ped.ped5.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped5.drawclothesY = math.floor(ped.ped5.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped5.drawclothesX = math.floor(ped.ped5.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped6.x = math.floor(ped.ped6.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped6.y = math.floor(ped.ped6.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped6.drawclothesY = math.floor(ped.ped6.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped6.drawclothesX = math.floor(ped.ped6.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped7.x = math.floor(ped.ped7.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped7.y = math.floor(ped.ped7.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped7.drawclothesY = math.floor(ped.ped7.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped6.drawclothesX = math.floor(ped.ped7.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped8.x = math.floor(ped.ped8.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped8.y = math.floor(ped.ped8.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped8.drawclothesY = math.floor(ped.ped8.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped8.drawclothesX = math.floor(ped.ped8.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped9.x = math.floor(ped.ped9.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped9.y = math.floor(ped.ped9.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped9.drawclothesY = math.floor(ped.ped9.y - math.sin(veh.playercar.rounded) * veh.playercar.speed)
		ped.ped9.drawclothesX = math.floor(ped.ped9.x - math.cos(veh.playercar.rounded) * veh.playercar.speed)
	
end

function updatenpcs(dir)
	if dir == 1 then -- north/up
		-- ped drawpos
		ped.ped1.y = ped.ped1.y + player.speed
		ped.ped2.y = ped.ped2.y + player.speed
		ped.ped3.y = ped.ped3.y + player.speed
		ped.ped4.y = ped.ped4.y + player.speed
		ped.ped5.y = ped.ped5.y + player.speed
		ped.ped6.y = ped.ped6.y + player.speed
		ped.ped7.y = ped.ped7.y + player.speed
		ped.ped8.y = ped.ped8.y + player.speed
		ped.ped9.y = ped.ped9.y + player.speed
		ped.ped0.y = ped.ped0.y + player.speed
		if player.dragy ~= nil then
			n.npcpath.y = n.npcpath.y - player.speed
		end
		-- nametags
		ped.ped1.drawnameY = ped.ped1.drawnameY + player.speed
		ped.ped2.drawnameY = ped.ped2.drawnameY + player.speed
		ped.ped3.drawnameY = ped.ped3.drawnameY + player.speed
		ped.ped4.drawnameY = ped.ped4.drawnameY + player.speed
		ped.ped5.drawnameY = ped.ped5.drawnameY + player.speed
		ped.ped6.drawnameY = ped.ped6.drawnameY + player.speed
		ped.ped7.drawnameY = ped.ped7.drawnameY + player.speed
		ped.ped8.drawnameY = ped.ped8.drawnameY + player.speed
		ped.ped9.drawnameY = ped.ped9.drawnameY + player.speed
		ped.ped0.drawnameY = ped.ped0.drawnameY + player.speed
		-- ped clothes
		ped.ped1.drawclothesY = ped.ped1.y
		ped.ped2.drawclothesY = ped.ped2.y
		ped.ped3.drawclothesY = ped.ped3.y
		ped.ped4.drawclothesY = ped.ped4.y
		ped.ped5.drawclothesY = ped.ped5.y
		ped.ped6.drawclothesY = ped.ped6.y
		ped.ped7.drawclothesY = ped.ped7.y
		ped.ped8.drawclothesY = ped.ped8.y
		ped.ped9.drawclothesY = ped.ped9.y
		ped.ped0.drawclothesY = ped.ped0.y
		if player.dragy ~= nil then
			n.npcpath.drawnameY = n.npcpath.drawnameY - player.speed
		end
		-- vehs
		if veh.playercar.isparked == true then veh.playercar.drawy = veh.playercar.drawy + player.speed end
		end
	if dir == 2 then -- east/right
		-- ped drawpos
		ped.ped1.x = ped.ped1.x - player.speed
		ped.ped2.x = ped.ped2.x - player.speed
		ped.ped3.x = ped.ped3.x - player.speed
		ped.ped4.x = ped.ped4.x - player.speed
		ped.ped5.x = ped.ped5.x - player.speed
		ped.ped6.x = ped.ped6.x - player.speed
		ped.ped7.x = ped.ped7.x - player.speed
		ped.ped8.x = ped.ped8.x - player.speed
		ped.ped9.x = ped.ped9.x - player.speed
		ped.ped0.x = ped.ped0.x - player.speed
		if player.dragx ~= nil then
			n.npcpath.x = n.npcpath.x + player.speed
		end
		-- nametags
		ped.ped1.drawnameX = ped.ped1.drawnameX - player.speed
		ped.ped2.drawnameX = ped.ped2.drawnameX - player.speed
		ped.ped3.drawnameX = ped.ped3.drawnameX - player.speed
		ped.ped4.drawnameX = ped.ped4.drawnameX - player.speed
		ped.ped5.drawnameX = ped.ped5.drawnameX - player.speed
		ped.ped6.drawnameX = ped.ped6.drawnameX - player.speed
		ped.ped7.drawnameX = ped.ped7.drawnameX - player.speed
		ped.ped8.drawnameX = ped.ped8.drawnameX - player.speed
		ped.ped9.drawnameX = ped.ped9.drawnameX - player.speed
		ped.ped0.drawnameX = ped.ped0.drawnameX - player.speed
		-- ped clothes
		ped.ped1.drawclothesX = ped.ped1.x
		ped.ped2.drawclothesX = ped.ped2.x
		ped.ped3.drawclothesX = ped.ped3.x
		ped.ped4.drawclothesX = ped.ped4.x
		ped.ped5.drawclothesX = ped.ped5.x
		ped.ped6.drawclothesX = ped.ped6.x
		ped.ped7.drawclothesX = ped.ped7.x
		ped.ped8.drawclothesX = ped.ped8.x
		ped.ped9.drawclothesX = ped.ped9.x
		ped.ped0.drawclothesX = ped.ped0.x
		if player.dragx ~= nil then
			n.npcpath.drawnameX = n.npcpath.drawnameX + player.speed
		end		
		-- vehs
		if veh.playercar.isparked == true then veh.playercar.drawx = veh.playercar.drawx - player.speed end
	end
	if dir == 3 then -- south/down
		-- ped drawpos
		ped.ped1.y = ped.ped1.y - player.speed
		ped.ped2.y = ped.ped2.y - player.speed
		ped.ped3.y = ped.ped3.y - player.speed
		ped.ped4.y = ped.ped4.y - player.speed
		ped.ped5.y = ped.ped5.y - player.speed
		ped.ped6.y = ped.ped6.y - player.speed
		ped.ped7.y = ped.ped7.y - player.speed
		ped.ped8.y = ped.ped8.y - player.speed
		ped.ped9.y = ped.ped9.y - player.speed
		ped.ped0.y = ped.ped0.y - player.speed
		if player.dragy ~= nil then
			n.npcpath.y = n.npcpath.y + player.speed
		end
		-- nametags
		ped.ped1.drawnameY = ped.ped1.drawnameY - player.speed
		ped.ped2.drawnameY = ped.ped2.drawnameY - player.speed
		ped.ped3.drawnameY = ped.ped3.drawnameY - player.speed
		ped.ped4.drawnameY = ped.ped4.drawnameY - player.speed
		ped.ped5.drawnameY = ped.ped5.drawnameY - player.speed
		ped.ped6.drawnameY = ped.ped6.drawnameY - player.speed
		ped.ped7.drawnameY = ped.ped7.drawnameY - player.speed
		ped.ped8.drawnameY = ped.ped8.drawnameY - player.speed
		ped.ped9.drawnameY = ped.ped9.drawnameY - player.speed
		ped.ped0.drawnameY = ped.ped0.drawnameY - player.speed
		-- ped clothes
		ped.ped1.drawclothesY = ped.ped1.y
		ped.ped2.drawclothesY = ped.ped2.y
		ped.ped3.drawclothesY = ped.ped3.y
		ped.ped4.drawclothesY = ped.ped4.y
		ped.ped5.drawclothesY = ped.ped5.y
		ped.ped6.drawclothesY = ped.ped6.y
		ped.ped7.drawclothesY = ped.ped7.y
		ped.ped8.drawclothesY = ped.ped8.y
		ped.ped9.drawclothesY = ped.ped9.y
		ped.ped0.drawclothesY = ped.ped0.y
		if player.dragy ~= nil then
			n.npcpath.drawnameY = n.npcpath.drawnameY + player.speed
		end		
		-- vehs
		if veh.playercar.isparked == true then veh.playercar.drawy = veh.playercar.drawy - player.speed end
	end
	if dir == 4 then -- west/left
		-- ped drawpos
		ped.ped1.x = ped.ped1.x + player.speed
		ped.ped2.x = ped.ped2.x + player.speed
		ped.ped3.x = ped.ped3.x + player.speed
		ped.ped4.x = ped.ped4.x + player.speed
		ped.ped5.x = ped.ped5.x + player.speed
		ped.ped6.x = ped.ped6.x + player.speed
		ped.ped7.x = ped.ped7.x + player.speed
		ped.ped8.x = ped.ped8.x + player.speed
		ped.ped9.x = ped.ped9.x + player.speed
		ped.ped0.x = ped.ped0.x + player.speed
		if player.dragx ~= nil then
			n.npcpath.x = n.npcpath.x - player.speed
		end
		-- nametags
		ped.ped1.drawnameX = ped.ped1.drawnameX + player.speed
		ped.ped2.drawnameX = ped.ped2.drawnameX + player.speed
		ped.ped3.drawnameX = ped.ped3.drawnameX + player.speed
		ped.ped4.drawnameX = ped.ped4.drawnameX + player.speed
		ped.ped5.drawnameX = ped.ped5.drawnameX + player.speed
		ped.ped6.drawnameX = ped.ped6.drawnameX + player.speed
		ped.ped7.drawnameX = ped.ped7.drawnameX + player.speed
		ped.ped8.drawnameX = ped.ped8.drawnameX + player.speed
		ped.ped9.drawnameX = ped.ped9.drawnameX + player.speed
		ped.ped0.drawnameX = ped.ped0.drawnameX + player.speed
		-- ped clothes
		ped.ped1.drawclothesX = ped.ped1.x
		ped.ped2.drawclothesX = ped.ped2.x
		ped.ped3.drawclothesX = ped.ped3.x
		ped.ped4.drawclothesX = ped.ped4.x
		ped.ped5.drawclothesX = ped.ped5.x
		ped.ped6.drawclothesX = ped.ped6.x
		ped.ped7.drawclothesX = ped.ped7.x
		ped.ped8.drawclothesX = ped.ped8.x
		ped.ped9.drawclothesX = ped.ped9.x
		ped.ped0.drawclothesX = ped.ped0.x
		if player.dragx ~= nil then
			n.npcpath.drawnameX = n.npcpath.drawnameX - player.speed
		end
		-- vehs
		if veh.playercar.isparked == true then veh.playercar.drawx = veh.playercar.drawx + player.speed end
	end
end

function erasedealers()
pedlist.place(nil)
	print("[debug] Erasing dealers.")
	-- TODO: new random ped/npc character spawn system
end

function placenpcs(density)
	local savex = world.x
	local savey = world.y
	world.x = -750
	world.y = -750
	print("(!!!) [main, placenpcs] RAN! Placing at density "..density.."!\n")
	if city.hood == 9 then pedlist.placegang(1) end
	if city.hood == 8 then pedlist.placegang(1) end
	if city.hood == 2 or city.hood == 3 then pedlist.placegang(2) end
	if city.hood == 7 then pedlist.placegang(3) end
	if city.hood == 6 then pedlist.placegang(4) end
	if density == 999 then pedlist.placenone() end
	pedlist.placepd()
	pedlist.placeciv()
	local dxmin = -125 * density
	local dxmax = 125 * density
	local dymin = -125 * density
	local dymax = 125 * density
	if savex >= 0 then dxmin = 125 * density; dxmax = 400 * density end -- off-world placement patch
	if savex <= -1400 then dxmin = -125 * density; dxmax = -400 * density end
	if savey >= 0 then dymin = 125 * density; dymax = 250 * density end
	if savey <= -1400 then dymin = -125 * density; dymax = -250 * density end
	ped.ped1.x = love.math.random(dxmin, dxmax)
	ped.ped1.y = love.math.random(dymin, dymax)
	ped.ped2.x = love.math.random(dxmin, dxmax)
	ped.ped2.y = love.math.random(dymin, dymax)
	ped.ped3.x = love.math.random(dxmin, dxmax)
	ped.ped3.y = love.math.random(dymin, dymax)
	ped.ped4.x = love.math.random(dxmin, dxmax)
	ped.ped4.y = love.math.random(dymin, dymax)
	ped.ped5.x = love.math.random(dxmin, dxmax)
	ped.ped5.y = love.math.random(dymin, dymax)
	ped.ped6.x = love.math.random(dxmin, dxmax)
	ped.ped6.y = love.math.random(dymin, dymax)
	ped.ped7.x = love.math.random(dxmin, dxmax)
	ped.ped7.y = love.math.random(dymin, dymax)
	ped.ped8.x = love.math.random(dxmin, dxmax)
	ped.ped8.y = love.math.random(dymin, dymax)
	ped.ped9.x = love.math.random(dxmin, dxmax)
	ped.ped9.y = love.math.random(dymin, dymax)
	ped.ped0.x = love.math.random(dxmin, dxmax)
	ped.ped0.y = love.math.random(dymin, dymax)
	ped.ped1.clothes = txtrs.clothes.none
	ped.ped2.clothes = txtrs.clothes.none
	ped.ped3.clothes = txtrs.clothes.none
	ped.ped4.clothes = txtrs.clothes.none
	ped.ped5.clothes = txtrs.clothes.none
	ped.ped6.clothes = txtrs.clothes.none
	ped.ped7.clothes = txtrs.clothes.none
	ped.ped8.clothes = txtrs.clothes.none
	ped.ped9.clothes = txtrs.clothes.none
	ped.ped0.clothes = txtrs.clothes.none
	-- uncuff all
	ped.ped1.incuffs = false
	ped.ped2.incuffs = false
	ped.ped3.incuffs = false
	ped.ped4.incuffs = false
	ped.ped5.incuffs = false
	ped.ped6.incuffs = false
	ped.ped7.incuffs = false
	ped.ped8.incuffs = false
	ped.ped9.incuffs = false
	ped.ped0.incuffs = false
	-- restore wasrobbed all
	ped.ped1.wasrobbed = false; ped.ped2.wasrobbed = false; ped.ped3.wasrobbed = false; ped.ped4.wasrobbed = false; ped.ped5.wasrobbed = false; ped.ped6.wasrobbed = false; ped.ped7.wasrobbed = false; ped.ped8.wasrobbed = false; ped.ped9.wasrobbed = false; ped.ped0.wasrobbed = false
	-- heal all
	ped.ped1.hp = 100; ped.ped2.hp = 100; ped.ped3.hp = 100; ped.ped4.hp = 100; ped.ped5.hp = 100; ped.ped6.hp = 100; ped.ped7.hp = 100; ped.ped8.hp = 100; ped.ped9.hp = 100; ped.ped0.hp = 100
	if ped.ped1.isdrag == true then ped.ped1.x = player.x - 50; ped.ped1.y = player.y end
	if ped.ped2.isdrag == true then ped.ped2.x = player.x - 50; ped.ped2.y = player.y end
	if ped.ped3.isdrag == true then ped.ped3.x = player.x - 50; ped.ped3.y = player.y end
	if ped.ped4.isdrag == true then ped.ped4.x = player.x - 50; ped.ped4.y = player.y end
	if ped.ped5.isdrag == true then ped.ped5.x = player.x - 50; ped.ped5.y = player.y end
	if ped.ped6.isdrag == true then ped.ped6.x = player.x - 50; ped.ped6.y = player.y end
	if ped.ped7.isdrag == true then ped.ped7.x = player.x - 50; ped.ped7.y = player.y end
	if ped.ped8.isdrag == true then ped.ped8.x = player.x - 50; ped.ped8.y = player.y end
	if ped.ped9.isdrag == true then ped.ped9.x = player.x - 50; ped.ped9.y = player.y end
	if ped.ped0.isdrag == true then ped.ped0.x = player.x - 50; ped.ped0.y = player.y end
	-- then give an extra 100hp to cops as fake armor
	if ped.ped3.fac == "pd" then ped.ped3.hp = 200 end
	if ped.ped5.fac == "pd" then ped.ped5.hp = 200 end
	if ped.ped6.fac == "pd" then ped.ped6.hp = 200 end
	world.x = savex
	world.y = savey
	updatetags()
end

function updatetags()
	ped.ped1.drawnameX = ped.ped1.x - 50; ped.ped1.drawnameY= ped.ped1.y - 25
	ped.ped2.drawnameX = ped.ped2.x - 50; ped.ped2.drawnameY= ped.ped2.y - 25
	ped.ped3.drawnameX = ped.ped3.x - 50; ped.ped3.drawnameY= ped.ped3.y - 25
	ped.ped4.drawnameX = ped.ped4.x - 50; ped.ped4.drawnameY= ped.ped4.y - 25
	ped.ped5.drawnameX = ped.ped5.x - 50; ped.ped5.drawnameY= ped.ped5.y - 25
	ped.ped6.drawnameX = ped.ped6.x - 50; ped.ped6.drawnameY= ped.ped6.y - 25
	ped.ped7.drawnameX = ped.ped7.x - 50; ped.ped7.drawnameY= ped.ped7.y - 25
	ped.ped8.drawnameX = ped.ped8.x - 50; ped.ped8.drawnameY= ped.ped8.y - 25
	ped.ped9.drawnameX = ped.ped9.x - 50; ped.ped9.drawnameY= ped.ped9.y - 25
	ped.ped0.drawnameX = ped.ped0.x - 50; ped.ped0.drawnameY= ped.ped0.y - 25
end

function generatehouseicon(hood)
if hood == "parkwood" then
	if phouse.owned == false then
		misc.housedraw = "4sale"
		print("[debug] player has no house, house is 4sale")
	elseif phouse.owned == true and phouse.name == "1 South Drive" then misc.housedraw = "owned"
		print("player owns house here")
	end
end
end

function spawn(s)
	if s < 1 or s > 3 then print("[main.spawn] ERROR: SAVE FILE IS NIL; NOT SPAWNING"); return end
	print("[main] Running spawn() and placenpcs(4)...")
	txtrs.sky = txtrs.sky1
	audio.smenu:stop()
	world.x = love.math.random(-400, -500)
	world.y = love.math.random(-400, -500)
	placenpcs(4)
	if sets.devmode == "false" then
		n.devmode = false
		n.devtags = false
	end
	if sets.devmode == "true" then
		append(color.lblue, "Spawning with devmode...")
		n.devmode = true
		n.devtags = true
	end
	append(color.gray, "Use /load to load a different save.")
	cscript.runcmd("/load "..s)
end

function loadspawn()
	txtrs.sky = txtrs.sky1
	placenpcs(4)
end

function newdrift()
	print("[main, newdrift] RAN!")
	world.x = love.math.random(0, -1200); world.y = love.math.random(0, -1200)
	n.sdata.driftx = love.math.random(1,3) -- (1) left (2) right (3) nil
	n.sdata.drifty = love.math.random(1,3) -- (1) up (2) down (3) nil
	if world.x >= 0 then n.sdata.driftx = 2; append(color.lgray, "[main, newdrift] drift correction to right") end
	if world.x <= -1200 then n.sdata.driftx = 1; append(color.lgray, "[main, newdrift] drift correction to left") end
	if world.y >= 0 then n.sdata.drifty = 2; append(color.lgray, "[main, newdrift] drift correction to down") end
	if world.y <= -1200 then n.sdata.drifty = 1; append(color.lgray, "[main, newdrift] drift correction to up") end
end

function animwalk(direction)
	if player.canmove == true then
		if anim.walk >= anim.walkmax then
		anim.doidle = false
		if player.y == 250 then player.torsoY = 245 player.y = 245; data.weapony = 245 player.clothes.goreY = 245; anim.walk = 0; return else player.torsoY = 250 player.clothes.goreY = 250; data.weapony = 250; player.y = 250; anim.walk = 0 return end
		else
		if ((lk.isDown(sets.move_up) and not((lk.isDown(sets.move_dn))and not(lk.isDown(sets.move_rt)) and not lk.isDown(sets.move_lt)))) then
			svc.walkanim = svc.walkanim + 1 return
		end
		if ((lk.isDown(sets.move_dn) and not((lk.isDown(sets.move_up))and not(lk.isDown(sets.move_rt)) and not lk.isDown(sets.move_lt)))) then
			svc.walkanim = svc.walkanim + 1 return
		end		
		if ((lk.isDown(sets.move_lt) and not((lk.isDown(sets.move_dn))and not(lk.isDown(sets.move_rt)) and not lk.isDown(sets.move_up)))) then
			svc.walkanim = svc.walkanim + 1 return
		end		
		if ((lk.isDown(sets.move_rt) and not((lk.isDown(sets.move_dn))and not(lk.isDown(sets.move_up)) and not lk.isDown(sets.move_lt)))) then
			svc.walkanim = svc.walkanim + 1 return
		end	
		end
	end
		if direction == "up" then
			if anim.walkphase == 0 then anim.walkphase = 1 end
			if anim.walkphase == 1 then anim.walkphase = 0 end
			anim.dowalkup = true; anim.dowalkdown = false; player.ismoving = true
		end
		if direction == "down" then
		--	if anim.walkphase == 0 then txtrs.player = txtrs.playerdn1; anim.walkphase = 1; anim.walk = 0; return end
		--	if anim.walkphase == 1 then txtrs.player = txtrs.playerdn2; anim.walkphase = 0; anim.walk = 0; return end
			anim.dowalkdown = true; anim.dowalkup = false; player.ismoving = true
		end
		if direction == "right" then
			if lk.isDown(sets.move_up) then anim.dowalkup = true; anim.dowalkdown = false; player.ismoving = true end
		end
		if direction == "left" then
			if lk.isDown(sets.move_up) then anim.dowalkup = true; anim.dowalkdown = false; player.ismoving = true end
		end
end -- end of animwalk

function checktarget()
	if (n.mousex >= (ped.ped0.x) and n.mousex <= (ped.ped0.x + 40)) and (n.mousey >= (ped.ped0.y - 10) and n.mousey <= (ped.ped0.y + 60)) then ped.ped0.color = color.focus; ped.ped0.hasfocus = true
		else ped.ped0.color = color.white; ped.ped0.hasfocus = false
	end
	if (n.mousex >= (ped.ped1.x) and n.mousex <= (ped.ped1.x + 40)) and (n.mousey >= (ped.ped1.y - 10) and n.mousey <= (ped.ped1.y + 60)) then ped.ped1.color = color.focus; ped.ped1.hasfocus = true
		else ped.ped1.color = color.white; ped.ped1.hasfocus = false
	end
	if (n.mousex >= (ped.ped2.x) and n.mousex <= (ped.ped2.x + 40)) and (n.mousey >= (ped.ped2.y - 10) and n.mousey <= (ped.ped2.y + 60)) then ped.ped2.color = color.focus; ped.ped2.hasfocus = true
		else ped.ped2.color = color.white; ped.ped2.hasfocus = false
	end
	if (n.mousex >= (ped.ped3.x) and n.mousex <= (ped.ped3.x + 40)) and (n.mousey >= (ped.ped3.y - 10) and n.mousey <= (ped.ped3.y + 60)) then ped.ped3.color = color.focus; ped.ped3.hasfocus = true
		else ped.ped3.color = color.white; ped.ped3.hasfocus = false
	end
	if (n.mousex >= (ped.ped4.x) and n.mousex <= (ped.ped4.x + 40)) and (n.mousey >= (ped.ped4.y - 10) and n.mousey <= (ped.ped4.y + 60)) then ped.ped4.color = color.focus; ped.ped4.hasfocus = true
		else ped.ped4.color = color.white; ped.ped4.hasfocus = false
	end
	if (n.mousex >= (ped.ped5.x) and n.mousex <= (ped.ped5.x + 40)) and (n.mousey >= (ped.ped5.y - 10) and n.mousey <= (ped.ped5.y + 60)) then ped.ped5.color = color.focus; ped.ped5.hasfocus = true
		else ped.ped5.color = color.white; ped.ped5.hasfocus = false
	end
	if (n.mousex >= (ped.ped6.x) and n.mousex <= (ped.ped6.x + 40)) and (n.mousey >= (ped.ped6.y - 10) and n.mousey <= (ped.ped6.y + 60)) then ped.ped6.color = color.focus; ped.ped6.hasfocus = true
		else ped.ped6.color = color.white; ped.ped6.hasfocus = false
	end
	if (n.mousex >= (ped.ped7.x) and n.mousex <= (ped.ped7.x + 40)) and (n.mousey >= (ped.ped7.y - 10) and n.mousey <= (ped.ped7.y + 60)) then ped.ped7.color = color.focus; ped.ped7.hasfocus = true
		else ped.ped7.color = color.white; ped.ped7.hasfocus = false
	end
	if (n.mousex >= (ped.ped8.x) and n.mousex <= (ped.ped8.x + 40)) and (n.mousey >= (ped.ped8.y - 10) and n.mousey <= (ped.ped8.y + 60)) then ped.ped8.color = color.focus; ped.ped8.hasfocus = true
		else ped.ped8.color = color.white; ped.ped8.hasfocus = false
	end
	if (n.mousex >= (ped.ped9.x) and n.mousex <= (ped.ped9.x + 40)) and (n.mousey >= (ped.ped9.y - 10) and n.mousey <= (ped.ped9.y + 60)) then ped.ped9.color = color.focus; ped.ped9.hasfocus = true
		else ped.ped9.color = color.white; ped.ped9.hasfocus = false
	end
end -- end of checktarget

function wantedupdate()
	local coptorespond = love.math.random(1,3)
	local copid = nil
	if coptorespond == 1 then copid = 3 getpath2(copid) end; if coptorespond == 2 then copid = 5; getpath2(copid) end; if coptorespond == 3 then copid = 6; getpath2(copid) end
		event.ped = coptorespond
		event.new(1, copid, player.x, player.y)
		actuallyquickgascop = false
		event.eventcode = "copupdate-a"
end

function getpath(npc)
	print("[getpath] GETTING PATH FOR ID "..npc)
		if npc == 0 then n.npcpath = peds.ped0; n.npcpathid = 0 end
		if npc == 1 then n.npcpath = peds.ped1; n.npcpathid = 1 end
		if npc == 2 then n.npcpath = peds.ped2; n.npcpathid = 2 end
		if npc == 3 then n.npcpath = peds.ped3; n.npcpathid = 3 end
		if npc == 4 then n.npcpath = peds.ped4; n.npcpathid = 4 end
		if npc == 5 then n.npcpath = peds.ped5; n.npcpathid = 5 end
		if npc == 6 then n.npcpath = peds.ped6; n.npcpathid = 6 end
		if npc == 7 then n.npcpath = peds.ped7; n.npcpathid = 7 end
		if npc == 8 then n.npcpath = peds.ped8; n.npcpathid = 8 end
		if npc == 9 then n.npcpath = peds.ped9; n.npcpathid = 9 end
		if npc == "marker" then n.npcpath = n.marker; n.npcpathid = 999 end
end
function getpath2(npc)
	if npc == 0 then n.npcpath = ped.ped0; n.npcpathid = 0
		elseif npc == 1 then n.npcpath2 = ped.ped1; n.npcpath2id = 1
		elseif npc == 2 then n.npcpath2 = ped.ped2; n.npcpath2id = 2
		elseif npc == 3 then n.npcpath2 = ped.ped3; n.npcpath2id = 3
		elseif npc == 4 then n.npcpath2 = ped.ped4; n.npcpath2id = 4
		elseif npc == 5 then n.npcpath2 = ped.ped5; n.npcpath2id = 5
		elseif npc == 6 then n.npcpath2 = ped.ped6; n.npcpath2id = 6
		elseif npc == 7 then n.npcpath2 = ped.ped7; n.npcpath2id = 7
		elseif npc == 8 then n.npcpath2 = ped.ped8; n.npcpath2id = 8
		elseif npc == 9 then n.npcpath2 = ped.ped9; n.npcpath2id = 9
	end
end
function getanimpath(npc)
		if npc == 0 then n.animpath = anim.sprites.ped0 end
		if npc == 1 then n.animpath = anim.sprites.ped1 end
		if npc == 2 then n.animpath = anim.sprites.ped2 end
		if npc == 3 then n.animpath = anim.sprites.ped3 end
		if npc == 4 then n.animpath = anim.sprites.ped4 end
		if npc == 5 then n.animpath = anim.sprites.ped5 end
		if npc == 6 then n.animpath = anim.sprites.ped6 end
		if npc == 7 then n.animpath = anim.sprites.ped7 end
		if npc == 8 then n.animpath = anim.sprites.ped8 end
		if npc == 9 then n.animpath = anim.sprites.ped9 end
		if npc == "emt" then n.animpath = anim.sprites.pedEMT end
end
function lotto()
	if player.hasticket == true then
		local won = love.math.random(1,9)
		local wonbynpc = love.math.random(1,10)
		local incriment = love.math.random(100, 999)
		data.lotto = data.lotto + incriment
		if won == 9 then
			append(color.purple, "[Lottery] You have won the jackpot!")
			append(color.lgreen, "+$"..data.lotto)
			player.cash = player.cash + data.lotto
			data.lotto = 1000
		end
		if won ~= 9 and wonbynpc == 10 then
			append(color.purple, "[Lottery] The jackpot of $"..data.lotto.." has been won!")
			data.lotto = 1000
		end
		if won ~= 9 and wonbynpc ~= 10 then append(color.purple, "[Lottery] The jackpot has grown to $"..data.lotto.."!") end
	elseif player.hasticket == false then print("[lotto] function ran but player has no lottery ticket")
	end
end

function paycheck()
	local checkamount = 0
	local basepay = 0
	local tax = 4.4 * player.factionrankid -- average of 13.4 in early 90s
	local taxamount = 0
	local rankpay = player.factionrankid * 75 -- (1) 225 (2) 300 (3) 375
	local interestrate = math.floor(player.cash / 900) -- roughly 2-4% in early 90s	
	if interestrate <= 1 then interestrate = 2.0 end
	if interestrate >=  10 then interestrate = 10.0 end
	if player.factionrank == 4 then rankpay = 750 end
	if player.factionrank == 5 then rankpay = 1000 end
	if player.factionid == 1 or player.factionid == 2 or player.factionid == 6 then basepay = 150 elseif (player.factionid >= 3 and player.factionid <= 5) then basepay = 75 elseif player.factionid == 0 then basepay = 50 end
	taxamount = math.floor((basepay + rankpay) * (tax / 100))
	if player.factionid >= 3 and player.factionid <= 5 then taxamount = 0 end
	if basepay ~= 75 and basepay ~= 50 then checkamount = math.floor(basepay + rankpay) - taxamount else checkamount = math.floor(basepay); taxamount = 0 end
	local newbalance = (player.cash + checkamount)
	local interest = (math.floor(checkamount * (interestrate / 100)))
	if player.job_active == true then append(color.dred, "You failed to make the delivery in time. Task failed!"); checkamount = 0 end -- failed delivery job
	append(color.white, "-------------------------")
	append(color.lgray, "BANK STATEMENT")
	append(color.white, "Old balance: $"..player.cash..".00")
	if basepay == 75 or basepay == 50 then
		append(color.green, "Welfare auto-cashed: $"..checkamount..".00 - Interest ("..interestrate.."%): +$"..interest..".00")
		append(color.red, "[TAX] Income: -$"..taxamount..".00 - Property: -$00.00")
	elseif basepay == 150 then
		append(color.white, "("..player.faction.." "..player.factionrank.." - "..player.factionrankid.."/5)")
		append(color.green, "Paycheck: $"..basepay + rankpay..".00 - Interest ("..interestrate.."%): +$"..interest..".00")
		append(color.red, "[TAX] Income: -$"..taxamount..".00 - Property: -$00.00")
	end
	newbalance = player.cash + (checkamount + interest)
	player.cash = newbalance
	append(color.lgreen, "Deposited $"..(checkamount + interest).." - New balance: $"..newbalance..".00 ")
	append(color.white, "-------------------------")
	xp(love.math.random(2,5))
end

function checkproxi(domarker)
	if domarker == true then getpath("marker") end
	if n.npcpath.x >= 0 and n.npcpath.x <= 650 then n.canX = true
		else print("Ped is not close enough to player. (X)"); n.canX = false
	end -- end of X distance checker
	if n.npcpath.y >= 25 and n.npcpath.y <= 650 then n.canY = true
		else print("Ped is not close enough to player. (Y)"); n.canY = false
	end -- end of Y distance checker
	
end

function holsterall()
	peds.ped0.holstered = true
	peds.ped1.holstered = true
	peds.ped2.holstered = true
	peds.ped3.holstered = true
	peds.ped4.holstered = true
	peds.ped5.holstered = true
	peds.ped6.holstered = true
	peds.ped7.holstered = true
	peds.ped8.holstered = true
	peds.ped9.holstered = true
	peds.ped0.holstered = true
end

function savesettings()
-- TODO: impliment
end

function append(shade, text)
msg.line0 = msg.line1; msg.line1 = msg.line2; msg.line2 = msg.line3; msg.line3 = msg.line4; msg.line4 = msg.line5; msg.line5 = msg.line6; msg.line6 = msg.line7; msg.line7 = msg.line8; msg.line8 = msg.line9; msg.line9 = text
msg.color0 = msg.color1; msg.color1 = msg.color2; msg.color2 = msg.color3; msg.color3 = msg.color4; msg.color4 = msg.color5; msg.color5 = msg.color6; msg.color6 = msg.color7; msg.color7 = msg.color8; msg.color8 = msg.color9; msg.color9 = shade
-- TODO: save previous lines for older pages of chat
end